/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*nph-delete+port.c */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../lib/defs.h"
#include "filters.h"

static char filter[20];
static char action[10];
static char module[16];
static char file[40];
static char help[40];
FILE *tfh;
FILE *fh;

int filterlist(char *name,char *status,char *module,char *file,char *help)
{
	if(!strcmp(filter,name)){
		fprintf(tfh,"%s %s %s %s %s\n",name,action,module,file,help);
	} else {
		fprintf(tfh,"%s %s %s %s %s\n",name,status,module,file,help);
	}
	return(0);
}

int main(int argc,char *argv[])
{
	char str[256];

	/* check if password is still valid */
	if(html_system(CHECK_LOGIN)){
		exit(0);
	}

	/* read parameters from stdin */
	fgets(str,256,stdin);
	getparam(str,"filter=",filter,20);
	getparam(str,"action=",action,20);

	/* change the filter */
	tfh=tmpfile();
	filter_enum(filterlist);
	/* write it back to /etc file */
	fseek(tfh,0,0);

	fh=fopen(DB_FILTER,"w");
	while(!feof(tfh)){
		if(fscanf(tfh,"%s %s %s %s %s\n",filter,action,module,file,help)==5){
			fprintf(fh,"%s %s %s %s %s\n",filter,action,module,file,help);
		}
	}
	fclose(tfh);
	fclose(fh);
	chmod(DB_FILTER,S_IRUSR|S_IWUSR);	/* only we can read/write */

	html_system(RELOAD_FILTERS);
	return(0);
}

