/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include "../lib/defs.h"
#include "filters.h"

int filtertable(char *name,char *state,char *module,char *file,char *help)
{
	printf("<TR><TD><STRONG>%s</STRONG></TD><TD>%s</TD></TR>\n",name,state);
	return(0);
}
int filterhlist(char *name,char *state,char *module,char *file,char *help)
{
	printf("<OPTION VALUE=\"%s\">%s\n",name,name);
	return(0);
}
int filterlist(char *name,char *state,char *module,char *file,char *help)
{
	printf("<OPTION VALUE=\"%s\">%s [ %s ]\n",name,name,state);
	return(0);
}

int main(int argc,char *argv[])
{

	if(html_system(CHECK_LOGIN)){
		return(10);
	}

	html_title("FWT Filters");
	printf("<BODY>\n");
	printlinks(FWT_LINKS,NULL);
	printf("<H3>Filters</H3>\n");

	/* the change filter form */
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_CHANGE_FILTER);
	printf("<SELECT NAME=\"filter\">\n");
	filter_enum(filterlist);
	printf("</SELECT>\n");

	printf("<SELECT NAME=\"action\">\n");
	printf("<OPTION VALUE=\"ON\">ON\n");
	printf("<OPTION VALUE=\"OFF\">OFF\n");
	printf("</SELECT>\n");

	printf("<INPUT TYPE=\"submit\" VALUE=\"CHANGE FILTER\">\n");
	printf("<BR>\n");
	printf("</FORM>\n");

	/* the help filter form */
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_HELP_FILTER);
	printf("<SELECT NAME=\"filter\">\n");
	filter_enum(filterhlist);
	printf("</SELECT>\n");
	printf("<INPUT TYPE=\"submit\" VALUE=\"HELP\">\n");
	printf("<BR>\n");
	printf("</FORM>\n");

	/* the filter table */
	printf("<TABLE BORDER>\n");
	printf("<CAPTION><STRONG>Filter status</STRONG></CAPTION>\n");
	printf("<TR>\n");
	printf("<TH>Filter</TH><TH>Status</TH>\n");
	printf("</TR>\n");
	filter_enum(filtertable);
	printf("</TABLE>\n");
	
	printf("</BODY></HTML>\n");
	return(0);
}
	
