/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "../lib/defs.h"
#include "groups.h"

int listboxgroup(char *name,char *type,char *val)
{
	printf("<OPTION VALUE=\"%s\">%s [ %s ]\n",name,name,val);
	return(0);
}

int listtablegroup(char *name,char *type,char *val)
{
	printf("<TR> ");
	printf("<TD><STRONG>%s</STRONG></TD> ",name);
	printf("<TD>%s</TD>",val);
	printf("<TD>%s</TD>",type);
	printf("</TR>\n");
	return(0);
}

int main(int argc,char *argv[])
{

	if(html_system(CHECK_LOGIN)){
		return(10);
	}

	html_title("FWT Groups");
	printf("<BODY>\n");
	printlinks(FWT_LINKS,NULL);
	printf("<H3>Groups</H3>\n");

	/*stuff for adding new groups*/
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERYADDGROUP);
	printf("<STRONG>Name:</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"name\" SIZE=12 MAXLENGTH=12>\n");
	printf("<STRONG>Address:</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"addr0\" SIZE=3 MAXLENGTH=3>\n");
	printf("<STRONG>.</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"addr1\" SIZE=3 MAXLENGTH=3>\n");
	printf("<STRONG>.</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"addr2\" SIZE=3 MAXLENGTH=3>\n");
	printf("<STRONG>.</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"addr3\" SIZE=3 MAXLENGTH=3>\n");
	printf("<STRONG>/</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"netm\" SIZE=2 MAXLENGTH=2>\n");
	printf("<INPUT TYPE=\"submit\" VALUE=\"ADD GROUP\">\n");
	printf("<BR>\n");
	printf("</FORM>\n");

	/* edit and delete only if there are any items */
	if(groups_num(GROUPS_DB)){
		/* delete groups */
		printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERYDELETEGROUP);
		printf("<SELECT NAME=\"selected_if\">\n");
		groups_enum(GROUPS_DB,listboxgroup);
		printf("</SELECT>\n");
		printf("<INPUT TYPE=\"submit\" VALUE=\"DELETE GROUP\">\n");
		printf("<BR>\n");
		printf("</FORM>\n");

		/* edit groups */
		printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERYEDITGROUP);
		printf("<SELECT NAME=\"selected_if\">\n");
		groups_enum(GROUPS_DB,listboxgroup);
		printf("</SELECT>\n");
		printf("<INPUT TYPE=\"submit\" VALUE=\"EDIT GROUP\">\n");
		printf("<BR>\n");
		printf("</FORM>\n");
	}

	/*create the table of all groups*/ 
	printf("<TABLE BORDER>\n");
	printf("<CAPTION><STRONG>Current groups</STRONG></CAPTION>\n");
	printf("<TR>\n");
	printf("<TH> Name </TH> <TH> Object </TH> <TH> Type </TH>\n");
	printf("</TR>\n");
	groups_enum(GROUPS_ALL,listtablegroup);	
	printf("</TABLE>\n");
	printf("</BODY></HTML>\n");

	return(0);
}

