/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*queryaddgroups.c*/
#include <stdio.h>
#include <stdlib.h>
#include "../lib/defs.h"
#include "groups.h"

int main(int argc,char *argv[])
{
	char str[256];
	char name[16],addr0[5],addr1[5],addr2[5],addr3[5],netm[5];
	int a0,a1,a2,a3,nm;

	if(html_system(CHECK_LOGIN)){
		return(10);
	}

	fgets(str,256,stdin);
	getparam(str,"name=",name,16);
	getparam(str,"addr0=",addr0,5);	
	getparam(str,"addr1=",addr1,5);	
	getparam(str,"addr2=",addr2,5);	
	getparam(str,"addr3=",addr3,5);	
	getparam(str,"netm=",netm,5);	
	a0=atoi(addr0);
	a1=atoi(addr1);
	a2=atoi(addr2);
	a3=atoi(addr3);
	nm=atoi(netm);

	/* check that the name was specified and that it isnt used yet */
	if(!name[0]){
		GROUPS_ERROR("error_1");
		return(10);
	}

	/* check that the group doesnt exist yet */
	if(groups_getgroupvalbyname(GROUPS_DB,name)){
		GROUPS_ERROR("error_2");
		return(10);
	}

	/* everything looks ok, ask if to add it */
	html_title("Query Add Group");
	printf("<BODY>\n");
	printlinks(FWT_LINKS,NULL);
	printf("<H3>Add Group</H3>\n");
	printf("<p>Do you really want to add the group %s (%d.%d.%d.%d/%d)\n",name,a0,a1,a2,a3,nm);
	printf("to the system ?\n");
	printf("<BR>\n");

	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",ADDGROUP);
	printf("<INPUT TYPE=\"hidden\" NAME=\"name\" VALUE=\"%s\">\n",name);
	printf("<INPUT TYPE=\"hidden\" NAME=\"addr0\" VALUE=\"%d\">\n",a0);
	printf("<INPUT TYPE=\"hidden\" NAME=\"addr1\" VALUE=\"%d\">\n",a1);
	printf("<INPUT TYPE=\"hidden\" NAME=\"addr2\" VALUE=\"%d\">\n",a2);
	printf("<INPUT TYPE=\"hidden\" NAME=\"addr3\" VALUE=\"%d\">\n",a3);
	printf("<INPUT TYPE=\"hidden\" NAME=\"netm\" VALUE=\"%d\">\n",nm);
	printf("<INPUT TYPE=\"submit\" VALUE=\"YES, add %s\">\n",name);
	printf("</FORM>\n");

	printf("<FORM ACTION=\"%s\" METHOD=GET>\n",RELOADGROUP);
	printf("<INPUT TYPE=\"submit\" VALUE=\"CANCEL\">\n");
	printf("</FORM>\n");
	printf("</BODY></HTML>\n");

	return(0);
}

