/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include "../lib/defs.h"
#include "ifcfg.h"

char aliasif[16];

int getnewaliasname(char *iface)
{
	int alias;
	for(alias=0;alias<1000;alias++){
		sprintf(aliasif,"%s:%d\0",iface,alias);
		if(!groups_getgroupvalbyname(GROUPS_ALL,aliasif)){
			return(0);
		}
	}
	return(1);
}

int main(int argc,char *argv[])
{
	char str[256];
	char iface[16];

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,256,stdin);
	getparam(str,"create_alias=",iface,16);

	if(getnewaliasname(iface)){
		IFCFG_ERROR("error_13");exit(10);
	}
	
	html_title("FWT Create Alias");
	printf("<body>\n");
	printlinks(IFCFG_LINKS,NULL);
	printf("<h3>Create Alias %s</h3>\n",aliasif);
	printf("<strong>Interface %s</strong><br>\n",iface);
	printf("<strong>New Alias for this interface %s</strong><br>\n",aliasif);

	/* ip address and netmask */
	printf("<form action=\"%s\" method=post>\n",IFCFG_QUERYCREATEIF);
	printf("<input type=\"hidden\" name=\"iface\" value=\"%s\">\n",aliasif);
	printf("<strong>IP-address:</strong>\n");
	printf("<input type=\"text\" name=\"addr0\" value=\"\" size=3 maxlength=3>\n");
	printf("<strong>.</strong>");
	printf("<input type=\"text\" name=\"addr1\" value=\"\" size=3 maxlength=3>\n");
	printf("<strong>.</strong>");
	printf("<input type=\"text\" name=\"addr2\" value=\"\" size=3 maxlength=3>\n");
	printf("<strong>.</strong>");
	printf("<input type=\"text\" name=\"addr3\" value=\"\" size=3 maxlength=3>\n");
	printf("<strong>/</strong>");
	printf("<input type=\"text\" name=\"mask\" value=\"\" size=2 maxlength=2>\n");
	printf("<br><br>\n");

	/* execute button */
	printf("<input type=\"submit\" value=\"OK, CREATE IFACE %s\">\n",aliasif);
	printf("<br></form>\n");

	/* cancel button */
	printf("<form action=\"%s\" method=post>\n",IFCFG_RELOADIFCFG);
	printf("<input type=\"submit\" value=\"CANCEL\">\n");
	printf("</form><br>\n");

	printf("</body></html>\n");
	exit(0);
}
