/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include "../lib/defs.h"
#include "ifcfg.h"

int main(int argc,char *argv[])
{
	char str[256];
	char iface[16];
	struct IFDATA ifd;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,256,stdin);
	getparam(str,"delete_alias=",iface,16);
	ifcfg_getifdata(iface,&ifd);

	html_title("FWT Delete Alias");
	printf("<body>\n");
	printlinks(IFCFG_LINKS,NULL);
	printf("<h3>Delete Alias %s</h3>\n",iface);
	printf("Do you really want to delete the Alias <strong>%s?</strong>\n",iface);

	printf("<br><br>");
	printf("Alias: %s<br>\n",iface);
	printf("IP-addr: %d.%d.%d.%d/%d<br>\n",ifd.a0,ifd.a1,ifd.a2,ifd.a3,ifd.mask);
	printf("Broadcast: %d.%d.%d.%d<br>\n",ifd.b0,ifd.b1,ifd.b2,ifd.b3);
	printf("Network: %d.%d.%d.%d<br>\n",ifd.n0,ifd.n1,ifd.n2,ifd.n3);
	printf("<br>\n");

	/* execute button */
	printf("<form action=\"%s\" method=post>\n",IFCFG_QUERYDELETEALIAS);
	printf("<input type=\"hidden\" name=\"iface\" value=\"%s\">\n",iface);
	printf("<input type=\"submit\" value=\"OK, DELETE IFACE %s\">\n",iface);
	printf("<br></form>\n");

	/* cancel button */
	printf("<form action=\"%s\" method=post>\n",IFCFG_RELOADIFCFG);
	printf("<input type=\"submit\" value=\"CANCEL\">\n");
	printf("</form><br>\n");

	printf("</body></html>\n");
	exit(0);
}
