/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <net/if.h>
#include "../lib/defs.h"
#include "ifcfg.h"

int main(int argc,char *argv[])
{
	char str[256];
	char iface[16];
	struct IFDATA ifd;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,256,stdin);
	getparam(str,"edit_if=",iface,16);

	html_title("FWT Edit Interface");
	printf("<body>\n");
	printlinks(IFCFG_LINKS,NULL);
	printf("<h3>Edit Interface</h3>\n");
	printf("<strong>Interface %s</strong><br>\n",iface);
	ifcfg_getifdata(iface,&ifd);

	/* ip address and netmask */
	printf("<form action=\"%s\" method=post>\n",IFCFG_QUERYEDITIF);
	printf("<input type=\"hidden\" name=\"iface\" value=\"%s\">\n",iface);
	printf("<strong>IP-address:</strong>\n");
	printf("<input type=\"text\" name=\"addr0\" value=\"%d\" size=3 maxlength=3>\n",ifd.a0);
	printf("<strong>.</strong>");
	printf("<input type=\"text\" name=\"addr1\" value=\"%d\" size=3 maxlength=3>\n",ifd.a1);
	printf("<strong>.</strong>");
	printf("<input type=\"text\" name=\"addr2\" value=\"%d\" size=3 maxlength=3>\n",ifd.a2);
	printf("<strong>.</strong>");
	printf("<input type=\"text\" name=\"addr3\" value=\"%d\" size=3 maxlength=3>\n",ifd.a3);
	printf("<strong>/</strong>");
	printf("<input type=\"text\" name=\"mask\" value=\"%d\" size=2 maxlength=2>\n",ifd.mask);
	printf("<br><br>\n");

	/* status */
	printf("<strong>Status:</strong>\n");
	printf("<select name=\"current_status\">\n");
	printf("<option %s value=\"up\">UP\n",(ifd.flags&IFF_UP)?"selected":"");
	printf("<option %s value=\"down\">DOWN\n",(ifd.flags&IFF_UP)?"":"selected");
	printf("</select><br><br>\n");

	/* boot status */
	printf("<strong>Boot status:</strong>\n");
	printf("<select name=\"boot_status\">\n");
	printf("<option %s value=\"up\">UP\n",(ifd.onboot)?"selected":"");
	printf("<option %s value=\"down\">DOWN\n",(ifd.onboot)?"":"selected");
	printf("</select><br><br>\n");

	/* execute button */
	printf("<input type=\"submit\" value=\"OK, UPDATE IFACE %s\">\n",iface);
	printf("<br></form>\n");

	/* cancel button */
	printf("<form action=\"%s\" method=post>\n",IFCFG_RELOADIFCFG);
	printf("<input type=\"submit\" value=\"CANCEL\">\n");
	printf("</form><br>\n");

	printf("</body></html>\n");
	exit(0);
}

