/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include "../lib/defs.h"
#include "ifcfg.h"

int main(int argc,char *argv[])
{
	char str[256];
	FILE *fh;
	int a0,a1,a2,a3;
	int n0,n1,n2,n3;

	if(argc!=2){
		fprintf(stderr,"Usage: %s <ifname>\n",argv[0]);
		fprintf(stderr,"Prints Broadcast-address of interface <ifname>\n");
		exit(10);
	}

	sprintf(str,"%s/ifcfg-%s",IFCFGDIR,argv[1]);
	if(!(fh=fopen(str,"r"))){
		fprintf(stderr,"Could not find iface %s\n",argv[1]);
		exit(11);
	}

	while(!feof(fh)){
		fgets(str,256,fh);
		if(!strncmp(str,"IPADDR=",7)){
			sscanf(str+7,"%d.%d.%d.%d",&a0,&a1,&a2,&a3);
		}
		if(!strncmp(str,"NETMASK=",8)){
			sscanf(str+8,"%d.%d.%d.%d",&n0,&n1,&n2,&n3);
		}
	}

	printf("%d.%d.%d.%d",
		((~n0)|a0)&0xff,
		((~n1)|a1)&0xff,
		((~n2)|a2)&0xff,
		((~n3)|a3)&0xff);

	return(0);
}

