/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <net/if.h>
#include "../lib/defs.h"
#include "ifcfg.h"

int main(int argc,char *argv[])
{
	char str[256];
	char iface[8];
	char tmp[5];
	int a0,a1,a2,a3,mask,tmps;
	unsigned int addr,host;
	struct IFDATA ifd;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,256,stdin);
	getparam(str,"iface=",iface,16);
	getparam(str,"addr0=",tmp,4);a0=atol(tmp);
	getparam(str,"addr1=",tmp,4);a1=atol(tmp);
	getparam(str,"addr2=",tmp,4);a2=atol(tmp);
	getparam(str,"addr3=",tmp,4);a3=atol(tmp);
	getparam(str,"mask=",tmp,4);mask=atol(tmp);

	/* check that the IP address is valid */
	if( a0==127 ){
		IFCFG_ERROR("error_3");exit(10);
	}
	if( a0==0 ){
		IFCFG_ERROR("error_4");exit(10);
	}
	if( a0>223 ){
		IFCFG_ERROR("error_5");exit(10);
	}
	if( (a1<0)||(a1>255)||(a2<0)||(a2>255)||(a3<0)||(a3>255) ){
		IFCFG_ERROR("error_12");exit(10);
	}

	/* check that the netmask is valid */
	if( (mask<8) ){
		IFCFG_ERROR("error_1");exit(10);
	}
	if( (mask>30) ){
		IFCFG_ERROR("error_2");exit(10);
	}

	/* check that host-address is valid */
	addr=(a0<<24)|(a1<<16)|(a2<<8)|a3;
	host=addr&((1<<(32-mask))-1);
	if( host==((1<<(32-mask))-1) ){
		IFCFG_ERROR("error_6");exit(10);
	}
	if( host==0 ){
		IFCFG_ERROR("error_7");exit(10);
	}

	/* everything seems OK, dodastuff */
	/* new aliases are assumed to be up when created */
	ifd.flags=IFF_UP;
	ifd.onboot=1;
	
	ifd.a0=a0;
	ifd.a1=a1;
	ifd.a2=a2;
	ifd.a3=a3;
	ifd.mask=mask;
	tmps=(~((1L<<(32-mask))-1));
	ifd.b0=(ifd.a0|((~tmps)>>24))&0xff;
	ifd.b1=(ifd.a1|((~tmps)>>16))&0xff;
	ifd.b2=(ifd.a2|((~tmps)>> 8))&0xff;
	ifd.b3=(ifd.a3|((~tmps)    ))&0xff;

	ifd.n0=ifd.a0&(tmps>>24)&0xff;
	ifd.n1=ifd.a1&(tmps>>16)&0xff;
	ifd.n2=ifd.a2&(tmps>> 8)&0xff;
	ifd.n3=ifd.a3&(tmps    )&0xff;

	ifcfg_setifdata(iface,&ifd);
	ifcfg_writeifdata(iface,&ifd);
	html_system(IFCFG_RELOADIFCFG);	
	return(0);
}

