/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "../lib/defs.h"
#include "ifcfg.h"

int checkreferences(char *iface)
{
	char str[20];

	if(rules_numgrouprefs(RULES_ALL,iface))
		return(1);
	sprintf(str,"%s-net",iface);
	if(rules_numgrouprefs(RULES_ALL,str))
		return(1);
	sprintf(str,"%s-bcst",iface);
	if(rules_numgrouprefs(RULES_ALL,str))
		return(1);
	return(0);	
}

int main(int argc,char *argv[])
{
	char str[256];
	char iface[16];

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,256,stdin);
	getparam(str,"iface=",iface,16);

	if(checkreferences(iface)){
		IFCFG_ERROR("error_14");exit(10);
	}

	sprintf(str,"%s %s down",IFCONFIG,iface);
	system(str);
	sprintf(str,"%s/ifcfg-%s",IFCFGDIR,iface);
	unlink(str);

	html_system(IFCFG_RELOADIFCFG);
	exit(0);
}

