/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* getparam.c
** this function will extract http parameters sent by the client.
** getparam(char *params, char *name, char *val, int len)
**     params is the string of parameters as read from stdin
**              (e.g. "foo=1&bar=2")
**     name is the name of the parameter we wish to extract
**              in the example either foo or bar
**     val is the string where to store the variable 
**              in the example either "1" or "2"
**     len is the size of the string val.
**
** function will return
**  0: OK
** -1: no parameter with that name was founda
** -2: there was not enough space in val to store the value
*/

#include <stdio.h>
#include <string.h>
#include "defs.h"

int getparam(char *params,char *name,char *val,int len)
{
	unsigned char ch;
	char *str;
	*val=0;
	if(!(str=strstr(params,name)))
		return(-1);
	str+=strlen(name);
	for(;1;){
		if( (*str=='&')||(*str=='\n')||(*str==0) )
			break;
		/* '%' indicates special coded stuff */
		if( *str=='%' ){
			ch= chti(*(++str));
			ch= (ch<<4)+chti(*(++str));
			str++;
			*val++=ch;
		} else {	
			*val++ = *str++;
		}
		if(!(--len))
			return(-2);
	}
	*val=0;
	return(0);
}

