/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* groups_addgroup.c
** groups_addgroup(char *name,char *val)
** this function will change the definition of the specified
** userdefined group.
** if the group did not exist, it will be created.
**
** function will return
**  0: OK
*/
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"

static char *xname,*xval;
static int xflag;
static FILE *xfh;
static int static_callback(char *name,char *type,char *val)
{
	if(!strcmp(name,xname)){
		fprintf(xfh,"%s %s\n",name,xval);
		xflag=1;
	} else {
		fprintf(xfh,"%s %s\n",name,val);
	}
	return(0);
}

int groups_addgroup(char *name,char *val)
{
	xname=name;
	xflag=0;
	xval=val;
	xfh=fopen(DB_GROUPS".new","w");
	groups_enum(GROUPS_DB,static_callback);
	if(!xflag){
		fprintf(xfh,"%s %s\n",name,val);
	}
	fclose(xfh);
	unlink(DB_GROUPS);
	rename(DB_GROUPS".new",DB_GROUPS);
	chmod(DB_GROUPS,S_IRUSR|S_IWUSR);
	return(0);
}

