/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* groups_delgroup.c
** groups_delgroup(char *name)
** this function will remove the definition of the specified
** userdefined group.
**
** function will return
**  0: OK
*/
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"

static char *xname;
static int xflag;
static FILE *xfh;
static int static_callback(char *name,char *type,char *val)
{
	if(!strcmp(name,xname)){
		xflag=1;
	} else {
		fprintf(xfh,"%s %s\n",name,val);
	}
	return(0);
}

int groups_delgroup(char *name)
{
	xname=name;
	xflag=0;
	xfh=fopen(DB_GROUPS".new","w");
	groups_enum(GROUPS_DB,static_callback);
	fclose(xfh);
	if(xflag){
		unlink(DB_GROUPS);
		rename(DB_GROUPS".new",DB_GROUPS);
		chmod(DB_GROUPS,S_IRUSR|S_IWUSR);
	}
	return(0);
}

