/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* groups_getgroupvalbyname.c
** char *groups_getgroupvalbyname(int type,char *name)
** this function will return a pointer to a string containing the
** value the group evaluates to or NULL if no matching group
** was found.
** NOTE that the content of this static string is changed after each
** call to this function.
**
** type is 
** GROUPS_ALL
** GROUPS_SP
** GROUPS_DB
** GROUPS_IF
** GROUPS_IFNET
*/
#include <stdio.h>
#include <string.h>
#include "../defs.h"

static char *xname;
static int xflag;
static char xval[30];
static int static_callback(char *name,char *type,char *val)
{
	if(!strcmp(name,xname)){
		strncpy(xval,val,30);
		xflag=1;
	}
	return(0);
}

char *groups_getgroupvalbyname(int type,char *name)
{
	xname=name;
	xflag=0;
	groups_enum(type,static_callback);
	if(!xflag){
		return(NULL);
	}

	return(xval);
}


