/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* icmp.c */
#include <stdio.h>

struct icmp_typecode {
	char *name;
	char *value;
};

static struct icmp_typecode icmp_types[] =
{
	{	"ALL",				"ALL"},
	{	"Echo_Reply",			"echo-reply"},
	{	"Destination_Unreachable_(DU)",	"destination-unreachable"},
	{	"Source_Quench",		"source-quench"},
	{	"Redirect_(RE)",		"redirect"},
	{	"Echo_Request",			"echo-request"},
	{	"Router_Advertisement",		"router-advertisement"},
	{	"Router_Solicitation",		"router-solicitation"},
	{	"Time_Exceeded_(TE)",		"time-exceeded"},
	{	"Parameter_Problem_(PP)",	"parameter-problem"},
	{	"Timestamp_Request",		"timestamp-request"},
	{	"Timestamp_Reply",		"timestamp-reply"},
	{	"Address_Mask_Request",		"address-mask-request"},
	{	"Address_Mask_Reply",		"address-mask-reply"},
	{	NULL,				NULL}
};
static struct icmp_typecode icmp_codes[] =
{
	{	"ALL",				"ALL"},
	{	"DU:_Network_Unreachable",	"network-unreachable"},
	{	"DU:_Host_Unreachable",		"host-unreachable"},
	{	"DU:_Protocol_Unreachable",	"protocol-unreachable"},
	{	"DU:_Port_Unreachable",		"port-unreachable"},
	{	"DU:_Fragmentation_Needed",	"fragmentation-needed"},
	{	"DU:_Source_Route_Failed",	"source-route-failed"},
	{	"DU:_Network_Unknown",		"network-unknown"},
	{	"DU:_Host_Unknown",		"host-unknown"},
	{	"DU:_Network_Prohibited",	"network-prohibited"},
	{	"DU:_Host_Prohibited",		"host-prohibited"},
	{	"DU:_TOS_Network_Unreachable",	"TOS-network-unreachable"},
	{	"DU:_TOS_Host_Unreachable",	"TOS-host-unreachable"},
	{	"DU:_Communication_Prohibited",	"communication-prohibited"},
	{	"DU:_Host_Precedence_Violation","host-precedence-violation"},
	{	"DU:_Precedence_Cutoff",	"precedence-cutoff"},
	{	"RE:_Network_Redirect",		"network-redirect"},
	{	"RE:_Host_Redirect",		"host-redirect"},
	{	"RE:_TOS_Network_Redirect",	"TOS-network-redirect"},
	{	"RE:_TOS_Host_Redirect",	"TOS-host-redirect"},
	{	"TE:_TTL_Zero_During_Transmit",	"ttl-zero-during-transit"},
	{	"TE:_TTL_Zero_During_Reassembly","ttl-zero-during-reassembly"},
	{	"PP:_IP_Header_Bad",		"ip-header-bad"},
	{	"PP:_Required_Option_Missing",	"required-option-missing"},
	{	NULL,				NULL}
};


int icmp_typeenum(int (*callback)(char *name,char *value))
{
	int i;
	i=0;
	while(icmp_types[i].name){
		(*callback)(icmp_types[i].name,icmp_types[i].value);
		i++;
	}
	return(0);
}
int icmp_codeenum(int (*callback)(char *name,char *value))
{
	int i;
	i=0;
	while(icmp_codes[i].name){
		(*callback)(icmp_codes[i].name,icmp_codes[i].value);
		i++;
	}
	return(0);
}

