/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*ifcfg_writeifdata.c
**
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"

int ifcfg_writeifdata(char *ifname,struct IFDATA *ifd)
{
	FILE *fh;
	char fn[256];

	sprintf(fn,"%s/ifcfg-%s",IFCFGDIR,ifname);
	fh=fopen(fn,"w");
	fprintf(fh,"DEVICE=%s\n",ifname);
	fprintf(fh,"IPADDR=%d.%d.%d.%d\n",ifd->a0,ifd->a1,ifd->a2,ifd->a3);
	fprintf(fh,"NETMASK=%s\n",ifcfg_masktostring(ifd->mask));
	fprintf(fh,"NETWORK=%d.%d.%d.%d\n",ifd->n0,ifd->n1,ifd->n2,ifd->n3);
	fprintf(fh,"BROADCAST=%d.%d.%d.%d\n",ifd->b0,ifd->b1,ifd->b2,ifd->b3);
	fprintf(fh,"ONBOOT=%s\n",ifd->onboot?"yes":"no");
	fclose(fh);

	chmod(fn,S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
	return(0);
}

