/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* pr_add.c
 * this function will add the specified router(group) to be used as
 * a policyrouter.
 * function will return the designated mark value for this policy router
 * or <0 for failure to add it.
 *
 * The function will return
 * >0 mark value designated to this policy router
 * -1 could not add policy router, maxumum number of policy routers exceeded
 * -2 could not add policy router, this router(group) is already defined as
 *    a policy router.
 * -3 failure to access the policy router database file
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"


int pr_add(char *router)
{
	FILE *fh;
	int mark;

	if(pr_getbyrouter(router)){
		return(-2);
	}
	for(mark=MFW_POLROUTE_BASE;mark<(MFW_POLROUTE_BASE+MFW_POLROUTE_NUM);mark++){
		if(!pr_getbymark(mark)){
			if(!(fh=fopen(POLICYROUTERS,"a"))){
				return(-3);
			}
			fprintf(fh,"%d %s\n",mark,router);
			fclose(fh);
			chmod(POLICYROUTERS,S_IRUSR|S_IWUSR);
			return(mark);
		}
	}
	return(-1);
}


