/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* pr_addroute.c
 * this function will add the specified policy route at position pos
 * if pos<0 or pos>pr_numroutes(-1), the route will be appended to
 * the end of the list.
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"

static int spos;
static int flag;
static struct POLROUTING *spr;
static FILE *fh;
static int st_addroute(struct POLROUTING *pr)
{
	fprintf(fh,"%d %s %s %s %s %s %s %s %s\n",
		pr->mark,
		pr->protocol,
		pr->iface,
		pr->srcip,
		pr->srcport,
		pr->dstip,
		pr->dstport,
		pr->icmptype,
		pr->icmpcode
	);
	return(0);
}
static int callback(struct POLROUTING *pr)
{
	if(!spos--){
		st_addroute(spr);
		flag=1;
	}
	st_addroute(pr);
	return(0);
}

int pr_addroute(int pos,struct POLROUTING *pr)
{
	spr=pr;
	spos=pos;
	flag=0;
	if(!(fh=fopen(POLICYROUTING".new","w"))){
		return(0);
	}
	pr_enumroutes(-1,callback);
	if(!flag){
		st_addroute(pr);
	}
	fclose(fh);
	unlink(POLICYROUTING);
	rename(POLICYROUTING".new",POLICYROUTING);
	chmod(POLICYROUTING,S_IRUSR|S_IWUSR);
	return(0);
}


