/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* pr_del.c
 * this function will delete the policy router specified,
 * if there are any policy routes defined using that router, these will
 * be deleted also.
 * function will return :
 *  0: ok
 * -1: no such router found.
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"

static char *rt;
static FILE *fh;
static int callback(struct POLROUTER *pr)
{
	if(strcmp(pr->router,rt)){
		fprintf(fh,"%d %s\n",pr->mark,pr->router);
	}
	return(0);
}

int pr_del(char *router)
{
	struct POLROUTER *pr;

	pr=pr_getbyrouter(router);
	if(!pr){
		return(-1);
	}
	pr_delroute(-1,pr->mark);

	rt=router;
	fh=fopen(POLICYROUTERS".new","w");
	pr_enum(callback);
	fclose(fh);
	unlink(POLICYROUTERS);
	rename(POLICYROUTERS".new",POLICYROUTERS);
	chmod(POLICYROUTERS,S_IRUSR|S_IWUSR);
	return(0);
}

