/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* pr_delroute.c
 * if pos is non -1, the policy route at that position in the list
 * will be deleted.
 * also
 * if mark is non -1, all policy routes with that mark is deleted.
 * function will delete the number of routes deleted
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"

static int spos;
static int smark;
static int count;
static FILE *fh;


static int st_addroute(struct POLROUTING *pr)
{
	fprintf(fh,"%d %s %s %s %s %s %s %s %s\n",
		pr->mark,
		pr->protocol,
		pr->iface,
		pr->srcip,
		pr->srcport,
		pr->dstip,
		pr->dstport,
		pr->icmptype,
		pr->icmpcode
	);
	return(0);
}
static int callback(struct POLROUTING *pr)
{
	if(!spos--){
		count++;
		return(0);
	}
	if(smark==pr->mark){
		count++;
		return(0);
	}
	st_addroute(pr);
	return(0);
}

int pr_delroute(int pos,int mark)
{
	spos=pos;
	smark=mark;
	count=0;
	if(!(fh=fopen(POLICYROUTING".new","w"))){
		return(0);
	}
	pr_enumroutes(-1,callback);
	fclose(fh);
	unlink(POLICYROUTING);
	rename(POLICYROUTING".new",POLICYROUTING);
	chmod(POLICYROUTING,S_IRUSR|S_IWUSR);
	return(count);
}


