/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* pr_enum.c
 * this function will enumerate all defined policy routers, and call
 * callback if non NULL.
 * function will return the number of policy routers enumerated
 */

#include <stdio.h>
#include "../defs.h"

int pr_enum(int (*callback)(struct POLROUTER *pr))
{
	int count;
	FILE *fh;
	struct POLROUTER pr;

	count=0;
	if(!(fh=fopen(POLICYROUTERS,"r"))){
		return(0);
	}
	while(!feof(fh)){
		if(fscanf(fh,"%d %s\n",
			&pr.mark,
			pr.router
		)==2){
			count++;
			if(callback){
				(*callback)(&pr);
			}
		}
	}
	fclose(fh);
	return(count);
}

