/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* pr_enumroutes.c  policyrouting_enumroutes
 * this function will enumerate all policy routes matching mark mark
 * (mark represents which policy router the traffic is directed to)
 * mark==-1 is a wildcard which matches all routes.
 * Function will return the number of matching policy routes.
 * If callback is non NULL, it will be called
 */

#include <stdio.h>
#include "../defs.h"

int pr_enumroutes(int mark,int (*callback)(struct POLROUTING *pr))
{
	int match;
	FILE *fh;
	struct POLROUTING pr;

	match=0;
	if(!(fh=fopen(POLICYROUTING,"r"))){
		return(0);
	}
	while(!feof(fh)){
		if(fscanf(fh,"%d %s %s %s %s %s %s %s %s\n",
			&pr.mark,
			pr.protocol,
			pr.iface,
			pr.srcip,
			pr.srcport,
			pr.dstip,
			pr.dstport,
			pr.icmptype,
			pr.icmpcode
		)==9){
			if((mark==-1)||(mark==pr.mark)){
				match++;
				if(callback){
					(*callback)(&pr);
				}
			}
		}
	}
	fclose(fh);
	return(match);
}


