/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* pr_getbymark.c
 * this function will locate and return the policy router which are identified
 * by mark.
 * if no such router were found the function will return NULL
 */

#include <stdio.h>
#include <string.h>
#include "../defs.h"

static struct POLROUTER *matchpr;
static int matchmark;
static int callback(struct POLROUTER *pr)
{
	static struct POLROUTER spr;
	if(matchmark==pr->mark){
		matchpr=&spr;
		memcpy(&spr,pr,sizeof(struct POLROUTER));
	}
	return(0);
}

struct POLROUTER *pr_getbymark(int mark)
{
	matchpr=NULL;
	matchmark=mark;
	pr_enum(callback);
	return(matchpr);
}

