/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* ports_delport.c
** ports_delport(char *name)
** this function will remove the definition of the specified
** userdefined port.
**
** function will return
**  0: OK
*/
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"

static char *xname;
static int xflag;
static FILE *xfh;
static int static_callback(char *name,char *type,int port1,int port2)
{
	if(!strcmp(name,xname)){
		xflag=1;
	} else {
		fprintf(xfh,"%s %d:%d\n",name,port1,port2);
	}
	return(0);
}

int ports_delport(char *name)
{
	xname=name;
	xflag=0;
	xfh=fopen(DB_PORTS".new","w");
	ports_enum(PORTS_DB,static_callback);
	fclose(xfh);
	if(xflag){
		unlink(DB_PORTS);
		rename(DB_PORTS".new",DB_PORTS);
		chmod(DB_PORTS,S_IRUSR|S_IWUSR);
	}
	return(0);
}

