/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* ports_getportsbyname.c
** ports_getportsbyname(int type,char *name,int *port1,int port2)
** type can be 
** PORTS_ALL : all ports known to firewall
** PORTS_DB  : all user defined ports in file DB_PORTS
** PORTS_SP  : all special ports statically defined in SP_PORTS
** PORTS_WK  : all wellknown ports as defined in WK_PORTS
**
** this function will search through all ports of the specified type
** for a match in name. 
** if a match is found port1 and port2 will be filled in with
** the corresponding values (if they are non NULL)
**
** function will return 
**  1: OK match was found
**  0: no port with the specified name found.
*/
#include <stdio.h>
#include <string.h>
#include "../defs.h"

static char *xname;
static int xflag,xport1,xport2;
static int static_callback(char *name,char *type,int port1,int port2){
	if(!strcmp(name,xname)){
		xflag=1;
		xport1=port1;
		xport2=port2;
	}
	return(0);
}

int ports_getportsbyname(int type,char *name,int *port1,int *port2)
{
	xflag=0;
	xname=name;
	ports_enum(PORTS_ALL,static_callback);
	if(xflag){
		if(port1)*port1=xport1;
		if(port2)*port2=xport2;
		return(1);
	}
	return(0);
}

