/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*ppp_getpppdata.c
**
*/

#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include "../defs.h"

int ppp_getpppdata(char *iface,struct PPPDATA *pd)
{
	FILE *fh;
	char str[256];
	struct ifreq ifr;
	int sfd;

	/* connected status */
	sfd=socket(AF_INET,SOCK_DGRAM,0);
	memcpy(ifr.ifr_name,iface,IFNAMSIZ);
	pd->connected=0;
	if( !ioctl(sfd,SIOCGIFFLAGS,&ifr) ){
		if(ifr.ifr_ifru.ifru_flags&IFF_UP){
			pd->connected=1;
		}
	}
	close(sfd);

	sprintf(str,"%s/config-%s",PPPDIR,iface);
	if( !(fh=fopen(str,"r")) ){
		strcpy(pd->name,iface);
		pd->enabled=0;
		pd->speed=38400;
		strcpy(pd->dev,"cua0");
		strcpy(pd->dev,"pap");
		strcpy(pd->phone,"");
		strcpy(pd->username,"username");
		return(1);
	}

	pd->enabled=1;
	fscanf(fh,"%d %s %s %s %s",&pd->speed,pd->dev,pd->auth,pd->phone,
		pd->username);
	fclose(fh);
	return(0);
}

