/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*ppp_savepppdata.c
**
*/

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <net/if.h>
#include <pwd.h>
#include "../defs.h"

int ppp_savepppdata(struct PPPDATA *pd)
{
	FILE *fh;
	char str[256];

	sprintf(str,"%s/config-%s",PPPDIR,pd->name);
	if( !(fh=fopen(str,"w")) ){
		return(1);
	}
	fprintf(fh,"%d %s %s %s %s",pd->speed,pd->dev,pd->auth,pd->phone,
		pd->username);
	fclose(fh);
	chown(str,getpwnam("fwt")->pw_uid,0);
	chmod(str,S_IRUSR|S_IWUSR);

	/* create ifcfg-file */
	sprintf(str,"%s/ifcfg-%s",IFCFGDIR,"ppp0");
	fh=fopen(str,"w");
	fprintf(fh,"DEVICE=%s\n",pd->name);
	fprintf(fh,"IPADDR=0.0.0.0\n");
	fprintf(fh,"NETMASK=255.255.255.255\n");
	fprintf(fh,"NETWORK=0.0.0.0\n");
	fprintf(fh,"BROADCAST=255.255.255.255\n");
	fprintf(fh,"ONBOOT=no\n");
	fclose(fh);
	chown(str,0,0);
	chmod(str,S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);
	

	return(0);
}

