/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*redir_create.c
**this function creates a new redirection with a unique mark value
**
** function will return
** 0: failed to create redir
** other: mark value of new redir
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"

int redir_create(char *iface,char *port)
{
	int i;
	FILE *fh;
	for(i=MFW_REDIRECT_BASE;i<(MFW_REDIRECT_BASE+MFW_REDIRECT_NUM);i++){
		if(!redir_getredirbymark(i)){
			fh=fopen(TCPREDIR_FILE,"a");
			fprintf(fh,"%d %s %s\n",i,iface,port);
			fclose(fh);
			chmod(TCPREDIR_FILE,S_IRUSR|S_IWUSR);
			return(i);
		}
	}
	return(0);
}

			
