/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*redir_del.c
**int redir_del(int mark)
*/

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "../defs.h"

static FILE *xfh;
static int xmark;
static int static_callback(struct REDIR *redir)
{
	if(xmark!=redir->mark)
		fprintf(xfh,"%d %s %s\n",redir->mark,redir->iface,redir->port);
	return(0);
}

int redir_del(int mark)
{
	redir_deltarget(mark,NULL,NULL);
	xmark=mark;		
	xfh=fopen(TCPREDIR_FILE".new","w");
	redir_enum(static_callback);
	fclose(xfh);
	unlink(TCPREDIR_FILE);
	rename(TCPREDIR_FILE".new",TCPREDIR_FILE);
	chmod(TCPREDIR_FILE,S_IRUSR|S_IWUSR);
	return(0);
}

