/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*redir_deltarget.c
**int redir_deltarget(int mark,char *target)
** delets the specified mark,target combination or
** if target is NULL, all with matching mark.
** if port is NULL, all mathcing target,ports will be deleted.
** returns umber of targets deleted.
*/

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "../defs.h"

static FILE *xfh;
static int xnum;
static char *xtarget;
static char *xport;
static int xmark;
static int static_callback(struct REDIR_TARGET *rt)
{
	if(xmark==rt->mark){
		if(xtarget){
			if(!strcmp(xtarget,rt->host)){
				if(xport){
					if(!strcmp(xport,rt->port)){
						xnum++;
					} else {
						fprintf(xfh,"%d %s %s\n",rt->mark,rt->host,rt->port);
					}
				} else {
					xnum++;
				}
			} else {
				fprintf(xfh,"%d %s %s\n",rt->mark,rt->host,rt->port);
			}
		} else {
			xnum++;
		}
	} else {
		fprintf(xfh,"%d %s %s\n",rt->mark,rt->host,rt->port);
	}
	return(0);
}

	
int redir_deltarget(int mark,char *target,char *port)
{
	xnum=0;
	xmark=mark;
	xtarget=target;
	xport=port;
	xfh=fopen(TCPREDIR_TARGET".new","w");
	redir_targetenum(-1,static_callback);
	fclose(xfh);
	if(xnum){
		unlink(TCPREDIR_TARGET);
		rename(TCPREDIR_TARGET".new",TCPREDIR_TARGET);
		chmod(TCPREDIR_TARGET,S_IRUSR|S_IWUSR);
	}
	return(xnum);
}

