/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* redir_targetenum.c
 * enumerate all redirection targets with matching mark value.
 * if mark==-1, all redirections will be enumerated.
 * if callback is !NULL, it will be called.
 * returns number of matching redirection targets.
*/

#include <stdio.h>
#include "../defs.h"

int redir_targetenum(int mark,int (*callback)(struct REDIR_TARGET *target))
{
	struct REDIR_TARGET target;
	int i;
	FILE *fh;

	i=0;
	if(fh=fopen(TCPREDIR_TARGET,"r")){
		while(!feof(fh)){
			while(fscanf(fh,"%d %s %s\n",&target.mark,target.host,target.port)
				== 3){
				if( (mark<0) || (target.mark==mark) ){
					i++;
					if(callback)
						(*callback)(&target);
				}
			}
		}
		fclose(fh);
	}
	return(i);
}

