/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* route_delroute.c
 * this function will delete the route to the indicated target.
 * function will return:
 * 0: route deleted
 * 1: route did not exist
 */


#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../defs.h"

static int flag;
static FILE *fh;
static char *deltarget;

static int callback(char *typename,struct STROUTE *str)
{
	if(strcmp(deltarget,str->target)){
		fprintf(fh,"%s %s %s %s\n",
			str->iface,str->target,
			str->gateway,str->ttype);
	} else {
		flag=1;
	}
	return(0);
}

int route_delroute(char *target)
{
	int a0,a1,a2,a3,nm;
	char cmd[256];
	char tg[32];
	char *ggg;

	if(!strcmp("default",target)){
		sprintf(cmd,"%s del -net 0.0.0.0 netmask 0.0.0.0 >/dev/null 2>/dev/null",ROUTE);
		system(cmd);
	} else {
		if(!(ggg=groups_getgroupvalbyname(GROUPS_DB,target))){
			return(1);
		}
		sscanf(ggg,"%d.%d.%d.%d/%d\n",&a0,&a1,&a2,&a3,&nm);
		if(nm==32){
		strcpy(tg,groups_getgroupvalbyname(GROUPS_DB,target));
		if(index(tg,'/'))*index(tg,'/')=0;
			sprintf(cmd,"%s del -host %s >/dev/null 2>/dev/null",
				ROUTE,
				tg
			);
			system(cmd);
		} else {
			strcpy(tg,groups_getgroupvalbyname(GROUPS_DB,target));
			if(index(tg,'/'))*index(tg,'/')=0;
			sprintf(cmd,"%s del -net %s netmask %s >/dev/null 2>/dev/null",
				ROUTE,
				tg,
				ifcfg_masktostring(nm)
			);
			system(cmd);
		}
	}

	flag=0;
	deltarget=target;
	fh=fopen(ROUTECFG".new","w");
	route_enum(ROUTES_USR,callback);	
	fclose(fh);

	unlink(ROUTECFG);
	rename(ROUTECFG".new",ROUTECFG);
	sprintf(cmd,"/bin/chown fwt:nobody %s >/dev/null 2>/dev/null",ROUTECFG);
	system(cmd);
	chmod(ROUTECFG,S_IRUSR|S_IWUSR);
	route_updatesysfiles();
	return(flag);
}

