/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* route_getgroupiface.c
 * this function will return the name of which physical interface
 * a specific target is connected to.
 * The function only works for targets connected directly on the
 * link of an interface.
 * If no matching interface exist, the function will return NULL
 */

#include <stdio.h>
#include <string.h>
#include "../defs.h"

static char target[32];
static char *iface;
static int callback(char *name,char *type,char *val)
{
	static char group[32];
	char tmpgroup[32];
	char *strp;

	strcpy(tmpgroup,name);
	if(groups_groupingroup(target,tmpgroup)){
		strcpy(group,tmpgroup);
		if(strp=index(group,':')){	/* strip alias to physical */
			strp=0;
		}
		iface=group;
	}	
	return(0);
}

char *route_getgroupiface(char *group)
{
	strcpy(target,group);
	iface=NULL;
	groups_enum(GROUPS_IF,callback);
	return(iface);
}

