/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */
/* route_numlocalroutestogroup.c
 * this very specialized function will calculate the number of local
 * (i.e. interface link) routes that exist to a specific group.
 * ie if eth0 == 1.1.1.1/16
 * and eth0:1 == 1.1.1.2/16
 * this count would be 2 for the group 1.1.1.3
 */

#include <stdio.h>
#include "../defs.h"

static int num;
static char subgroup[16],group[16];
static int callback(char *name,char *type,char *val)
{
	strcpy(group,name);
	num+=groups_groupingroup(subgroup,group);
	return(0);
}

int route_numlocalroutestogroup(char *group)
{
	strcpy(subgroup,group);
	num=0;
	groups_enum(GROUPS_IF,callback);
	return(num);
}

