/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*rules_getrulebyindex.c
** struct RULE *rules_getrulebyindex(int type,int idx)
** function will return static structure containing rule[idx] of type type
** or NULL if the rule does not exist.
** NOTE The returned value is stored in a static variable and will therefore
** not survive sequent calls to the function.
**
** type can be
** RULES_IN
** RULES_OU
** RULES_FW
*/

#include <stdio.h>
#include "../defs.h"

static struct RULE xrule;
static int xflag;
static int xidx;
static int static_callback(struct RULE *rule)
{
	if(!xidx--){
		memcpy(&xrule,rule,sizeof(struct RULE));
		xflag=1;
	}
	return(0);
}

struct RULE *rules_getrulebyindex(int type,int idx)
{
	xflag=0;
	xidx=idx;
	switch(type){
	case RULES_IN:
	case RULES_OU:
	case RULES_FW:
		rules_enum(type,static_callback);
		break;
	}
	if(xflag){
		return(&xrule);
	}
	return(NULL);
}

