/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*rules_numgrouprefs.c
**int rules_numgrouprefs(int type,char *group)
**this functions returns the number of times a group is referenced from
**the selected rulelists.
**a group may be referenced from the srcip, dstip or iface fields.
**
**type may be
** RULES_ALL
** RULES_IN
** RULES_OU
** RULES_FW
*/

#include <stdio.h>
#include <string.h>
#include "../defs.h"

static char *xgroup;
static int xnum;
static int static_callback(struct RULE *rule)
{
	if(!strcmp(xgroup,rule->srcip)){
		xnum++;
		return(0);
	}
	if(!strcmp(xgroup,rule->dstip)){
		xnum++;
		return(0);
	}
	if(!strcmp(xgroup,rule->iface)){
		xnum++;
		return(0);
	}
	return(0);
}

int rules_numgrouprefs(int type,char *group)
{
	xgroup=group;
	xnum=0;
	rules_enum(type,static_callback);
	return(xnum);
}

