/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*rules_numportrefs.c
**int rules_numportrefs(int type,char *group)
**this functions returns the number of times a port is referenced from
**the selected rulelists.
**a group may be referenced from the srcport or dstport fields.
**
**type may be
** RULES_ALL
** RULES_IN
** RULES_OU
** RULES_FW
*/

#include <stdio.h>
#include <string.h>
#include "../defs.h"

static char *xport;
static int xnum;
static int static_callback(struct RULE *rule)
{
	if(!strcmp(xport,rule->srcport)){
		xnum++;
		return(0);
	}
	if(!strcmp(xport,rule->dstport)){
		xnum++;
		return(0);
	}
	return(0);
}

int rules_numportrefs(int type,char *port)
{
	xport=port;
	xnum=0;
	rules_enum(type,static_callback);
	return(xnum);
}

