/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include "../lib/defs.h"
#include "login.h"


/* program will return :
 * 0 : OK, login was ok
 * else, not logged in
 */
int main(int argc,char *argv[])
{	
	struct stat file_stat;
	FILE *fh;
	char timestr[256];
	char okaddr[256];
	time_t t;
	/* check if password has expired */
	if(stat(PWD_OK,&file_stat)){
		unlink(PWD_OK);
		html_system(MAIN_LOGIN);
		exit(1);
	}
	if(file_stat.st_ctime < (time(NULL)-LOGIN_TIMEOUT)){
		unlink(PWD_OK);
		t=time(NULL);
		strftime(timestr,255,"%Y-%m-%d %H:%M",localtime(&t));
		fh=fopen(PWD_FAILED,"a");
		fprintf(fh,"%s Autologout connection from : %s\n",
			timestr,getenv("REMOTE_ADDR"));
		fclose(fh);
		chmod(PWD_FAILED,S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH); 
		sleep(2);
		html_system(MAIN_LOGIN);
		exit(1);
	} 	

	/* check that we connect from the logged in ip */
	bzero(okaddr,256);
	fh=fopen(PWD_OK,"r");
	fread(okaddr,255,1,fh);
	fclose(fh);
	
	if(getenv("REMOTE_ADDR") && strcmp(getenv("REMOTE_ADDR"),okaddr)){
		unlink(PWD_OK);
		t=time(NULL);
		strftime(timestr,255,"%Y-%m-%d %H:%M",localtime(&t));
		fh=fopen(PWD_FAILED,"a");
		fprintf(fh,"%s Unauthorized access attempt from : %s\n",
			timestr,getenv("REMOTE_ADDR"));
		fclose(fh);
		chmod(PWD_FAILED,S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH); 
		sleep(2);
		html_system(MAIN_LOGIN);
		exit(1);
	}

	/* ok, just touch file, and continue */
	chmod(PWD_OK,S_IRUSR|S_IWUSR); /* this will change ctime */
	exit(0);
}

		

