/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include "../lib/defs.h"
#include "login.h"

int main(int argc,char *argv[])
{	
	FILE *fh;
	char timestr[256];
	char okaddr[256];
	time_t t;
	char params[1024];
	char password[20];
	char realpwd[20];

	/* get stdin parameters */
	fgets(params,1023,stdin);
	getparam(params,"password=",password,20);

	/* get real password */
	fh=fopen(PWD,"r");
	fscanf(fh,"%s\n",realpwd);
	fclose(fh);

	/* check the specified password */
	if(!strcmp(password,realpwd)){
		/* password was ok, update files and continue */
		unlink(PWD_OK);
		fh=fopen(PWD_OK,"w");
		fprintf(fh,"%s",getenv("REMOTE_ADDR"));
		fclose(fh);
		chmod(PWD_OK,S_IRUSR|S_IWUSR);

		unlink(PWD_FAILED);
		fh=fopen(PWD_FAILED,"w");
		fclose(fh);
		chmod(PWD_FAILED,S_IRUSR|S_IWUSR);

		sleep(2);
		html_system(RELOAD_RULES);
		exit(0);
	}

	/* failed to login, record attempt and show failure screen */
	unlink(PWD_OK);
	t=time(NULL);
	strftime(timestr,255,"%Y-%m-%d %H:%M",localtime(&t));
	fh=fopen(PWD_FAILED,"a");
	fprintf(fh,"%s Failed login from ip %s\n",
		timestr,getenv("REMOTE_ADDR"));
	fclose(fh);
	chmod(PWD_FAILED,S_IRUSR|S_IWUSR);

	html_title("Login Failed");
	printf("<BODY>\n");
	printf("<H3>Firewall Login Failed</H3>\n");
	printf("<P>The specified password was not correct.\n");
	printf("Login procedure failed.\n");
	printf("<BR>\n");
	printf("<FORM ACTION=\"%s\" METHOD=GET>\n",RELOAD_LOGIN);
	printf("<INPUT TYPE=\"submit\" VALUE=\"Continue\">\n");
	printf("</FORM>\n");
	printf("</BODY></HTML>\n");

	exit(0);
}

