/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include "../lib/defs.h"
#include "polroute.h"


int main(int argc,char *argv[])
{
	char str[1024];
	char tmp[16];
	char iface[8];
	char protocol[16];
	char srcip[20];
	char srcport[20];
	char dstip[20];
	char dstport[20];
	char icmptype[20];
	char icmpcode[20];
	char router[20];
	int pos;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,1024,stdin);
	getparam(str,"iface=",iface,20);	
	getparam(str,"protocol=",protocol,20);	
	getparam(str,"srcip=",srcip,20);	
	getparam(str,"srcport=",srcport,20);	
	getparam(str,"dstip=",dstip,20);	
	getparam(str,"dstport=",dstport,20);	
	getparam(str,"icmptype=",icmptype,20);	
	getparam(str,"icmpcode=",icmpcode,20);	
	getparam(str,"router=",router,20);	
	getparam(str,"pos=",tmp,8);	
	sscanf(tmp,"%d",&pos);


	html_title("Add Policy Route");
	printf("<BODY>\n");
	printlinks(IFCFG_LINKS,NULL);
	printf("<H3>Add Policy Route</H3>\n");
	printf("Do you really want to add this policy route to the system?\n");
	printf("<br>\n");
	printf("<pre>\n");
	printf("Route all packets matching :\n");
	printf("  Protocol: <strong>%s</strong>\n",protocol);
	printf("  Received on Iface: <strong>%s</strong>\n",iface);
	if( (!strncmp(protocol,"tcp",3)) || (!strcmp(protocol,"udp")) ){
		printf("  Src IP: <strong>%s</strong>  Src Port:<strong>%s</strong>\n",srcip,srcport);
		printf("  Dst IP: <strong>%s</strong>  Dst Port:<strong>%s</strong>\n",dstip,dstport);
	} else {
		printf("  Src IP: <strong>%s</strong>\n",srcip);
		printf("  Dst IP: <strong>%s</strong>\n",dstip);
	}
	if(!strcmp(protocol,"icmp")){
		printf("  ICMP Type: <strong>%s</strong>  ICMP Code: <strong>%s</strong>\n",icmptype,icmpcode);
	}

	printf("Via Policy Router: <strong>%s</strong>\n",router);
	printf("</pre>\n");

	printf("<form action=\"%s\" method=post>\n",ADDPOLROUTE_POLROUTE);
	printf("<input type=hidden name=\"pos\" value=\"%d\">\n",pos);
	printf("<input type=hidden name=\"protocol\" value=\"%s\">\n",protocol);
	printf("<input type=hidden name=\"iface\" value=\"%s\">\n",iface);
	printf("<input type=hidden name=\"srcip\" value=\"%s\">\n",srcip);
	printf("<input type=hidden name=\"srcport\" value=\"%s\">\n",srcport);
	printf("<input type=hidden name=\"dstip\" value=\"%s\">\n",dstip);
	printf("<input type=hidden name=\"dstport\" value=\"%s\">\n",dstport);
	printf("<input type=hidden name=\"icmptype\" value=\"%s\">\n",icmptype);
	printf("<input type=hidden name=\"icmpcode\" value=\"%s\">\n",icmpcode);
	printf("<input type=hidden name=\"router\" value=\"%s\">\n",router);
	printf("<input type=submit value=\"Add This Policy Route\">\n");
	printf("</form>\n");

	printf("<form action=\"%s\" method=post>\n",RELOAD_POLROUTE);
	printf("<input type=submit value=\"CANCEL\">\n");
	printf("</form>\n");

	printf("</BODY></HTML>\n");
	exit(0);
}
