/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include "../lib/defs.h"
#include "polroute.h"


int main(int argc,char *argv[])
{
	char str[256];
	char tmp[16];
	int pos;
	struct POLROUTING *pr;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,256,stdin);
	getparam(str,"pos=",tmp,8);	
	sscanf(tmp,"%d",&pos);

	pr=pr_getroutebypos(pos,-1);

	html_title("Delete Policy Route");
	printf("<BODY>\n");
	printlinks(IFCFG_LINKS,NULL);
	printf("<H3>Delete Policy Route</H3>\n");
	printf("Do you really want to delete this policy route from the system?\n");
	printf("<br>\n");
	printf("<pre>\n");
	printf("  Protocol: <strong>%s</strong>\n",pr->protocol);
	printf("  Received on Iface: <strong>%s</strong>\n",pr->iface);
	if( (!strncmp(pr->protocol,"tcp",3)) 
          || (!strcmp(pr->protocol,"udp")) ){
		printf("  Src IP: <strong>%s</strong>  Src Port:<strong>%s</strong>\n",pr->srcip,pr->srcport);
		printf("  Dst IP: <strong>%s</strong>  Dst Port:<strong>%s</strong>\n",pr->dstip,pr->dstport);
	} else {
		printf("  Src IP: <strong>%s</strong>\n",pr->srcip);
		printf("  Dst IP: <strong>%s</strong>\n",pr->dstip);
	}
	if(!strcmp(pr->protocol,"icmp")){
		printf("  ICMP Type: <strong>%s</strong>  ICMP Code: <strong>%s</strong>\n",pr->icmptype,pr->icmpcode);
	}

	printf("  Which Is Routed Via: <strong>%s</strong>\n",
		pr_getbymark(pr->mark)->router);

	printf("</pre>\n");

	printf("<form action=\"%s\" method=post>\n",DELPOLROUTE_POLROUTE);
	printf("<input type=hidden name=\"pos\" value=\"%d\">\n",pos);
	printf("<input type=submit value=\"Delete This Policy Route\">\n");
	printf("</form>\n");

	printf("<form action=\"%s\" method=post>\n",RELOAD_POLROUTE);
	printf("<input type=submit value=\"CANCEL\">\n");
	printf("</form>\n");

	printf("</BODY></HTML>\n");
	exit(0);
}
