/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include "../lib/defs.h"
#include "polroute.h"

int listroutes(struct POLROUTING *pr)
{
	if((!strncmp(pr->protocol,"tcp",3))||(!strcmp(pr->protocol,"udp"))){
		printf("IF:<strong>%s</strong> PROTO:<strong>%s</strong> SRC:<strong>%s %s</strong> DST:<strong>%s %s</strong>\n",
			pr->iface,pr->protocol,
			pr->srcip,pr->srcport,pr->dstip,pr->dstport);
	} else if (!strcmp(pr->protocol,"icmp")){
		printf("IF:<strong>%s</strong> PROTO:<strong>%s</strong> SRC:<strong>%s</strong> DST:<strong>%s</strong> ICMP-Type:<strong>%s</strong> ICMP-Code:<strong>%s</strong>\n",
			pr->iface,pr->protocol,
			pr->srcip,pr->dstip,pr->icmptype,pr->icmpcode);
	} else {
		printf("IF:<strong>%s</strong> PROTO:<strong>%s</strong> SRC:<strong>%s</strong> DST:<strong>%s</strong>\n",
			pr->iface,pr->protocol,
			pr->srcip,pr->dstip);
	}
	return(0);
}

int main(int argc,char *argv[])
{
	char str[256];
	char router[20];
	struct POLROUTER *pr;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,256,stdin);
	getparam(str,"router=",router,20);	

	html_title("Delete Policy Router");
	printf("<BODY>\n");
	printlinks(IFCFG_LINKS,NULL);
	printf("<H3>Delete Policy Router</H3>\n");
	printf("Do you really want to delete this Policy Router?\n");
	printf("<pre>\n");
	printf("Policy Router: <strong>%s</strong>\n",router);
	pr=pr_getbyrouter(router);
	if(pr_numroutes(pr->mark)){
		printf("The following routes using this Policy router will\n");
		printf("also be deleted:\n");
		pr_enumroutes(pr->mark,listroutes);
	}
	printf("</pre>\n");
	printf("<form action=\"%s\" method=post>\n",DELROUTER_POLROUTE);
	printf("<input type=hidden name=\"router\" value=\"%s\">\n",router);
	printf("<input type=submit value=\"YES, Delete This Policy Router\">\n");
	printf("</form>\n");

	printf("<form action=\"%s\" method=post>\n",RELOAD_POLROUTE);
	printf("<input type=submit value=\"CANCEL\">\n");
	printf("</form>\n");

	printf("</BODY></HTML>\n");
	exit(0);
}

