/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*addport.c */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "../lib/defs.h"
#include "ports.h"

int main(int argc,char *argv[])
{
	char str[256];
	char portname[20],port0[8],port1[8];
	int p0,p1;

	/* check if password is still valid */
	if(html_system(CHECK_LOGIN)){
		exit(0);
	}

	/* read parameters from stdin */
	fgets(str,256,stdin);
	if(getparam(str,"name=",portname,20)){
		exit(10);
	}
	if(getparam(str,"port0=",port0,8)){
		exit(10);
	}
	if(getparam(str,"port1=",port1,8)){
		exit(10);
	}
	p0=atoi(port0);
	p1=atoi(port1);

	/* a range of a single port x-x is the same as the single port x */
	if(p0==p1){
		p1=0;
	}
	/* ERROR CHECKS */
	/* if no value for port0 was specified */
	if(p0==0){
		PORTS_ERROR("error_2");
		return(0);
	}
	/* port0 must be in interval ]0,65535] */
	if( (p0<1)||(p0>65535) ){
		PORTS_ERROR("error_3");
		exit(0);
	}
	/* port1 must be less than 65535 */
	if(p1>65535){
		PORTS_ERROR("error_3");
		exit(0);
	}
	/* if specified, port1 must be greater than port0 */
	if(p1){
		if(p0>p1){
			PORTS_ERROR("error_4");
			exit(0);
		}
	}

	ports_addport(portname,p0,p1);

	html_system(RELOAD_PORTS);
	return(0);
}


