/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* ports.c */
#include <stdio.h>
#include <stdlib.h>
#include "../lib/defs.h"
#include "ports.h"

int porttable(char *name,char *type,int port1,int port2)
{
	printf("<TR>");
	printf("<TD><STRONG>%s</STRONG></TD>",name);
	if(port2>0)printf("<TD>%d-%d</TD>",port1,port2);
	else       printf("<TD>%d</TD>",port1);
	printf("<TD>%s</TD>",type);
	printf("</TR>\n");
	return(0);
}

int portlist(char *name,char *type,int port1,int port2)
{
	if(port2>0)printf("<OPTION VALUE=\"%s\">%s [ %d-%d ]\n",
		  	name,name,port1,port2);
	else       printf("<OPTION VALUE=\"%s\">%s [ %d ]\n",
			name,name,port1);
	return(0);
}

int main(int argc,char *argv[])
{

	/* check login stuff */
	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	/* print ports screen */		
	html_title("FWT Ports");
	printf("<BODY>\n");
	printlinks(FWT_LINKS,NULL);
	printf("<H3>Ports</H3>\n");

	/* the ADD PORT form */
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_ADD_PORT);
	printf("<STRONG>Name:</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"name\" SIZE=12 MAXLENGTH=12>\n");
	printf("<STRONG>From:</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"port0\" SIZE=5 MAXLENGTH=5>\n");
	printf("<STRONG>To:</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"port1\" SIZE=5 MAXLENGTH=5>\n");
	printf("<INPUT TYPE=\"submit\" VALUE=\"ADD PORT\">\n");
	printf("<BR>\n");
	printf("</FORM>\n");

	/* check if there are any deletable/editable ports */
	if(ports_num(PORTS_DB)>0){
		/* the deletable ports */
		printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_DELETE_PORT);
		printf("<SELECT NAME=\"selected_port\">\n");
		ports_enum(PORTS_DB,portlist);
		printf("</SELECT>\n");
		printf("<INPUT TYPE=\"submit\" VALUE=\"DELETE PORT\">\n");
		printf("<BR>\n");
		printf("</FORM>\n");

		/* the editable ports */
		printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_EDIT_PORT);
		printf("<SELECT NAME=\"selected_port\">\n");
		ports_enum(PORTS_DB,portlist);
		printf("</SELECT>\n");
		printf("<INPUT TYPE=\"submit\" VALUE=\"EDIT PORT\">\n");
		printf("<BR>\n");
		printf("</FORM>\n");
	} 

	/* create table of all ports */
	printf("<TABLE BORDER>\n");
	printf("<CAPTION><STRONG>Current ports</STRONG></CAPTION>\n");
	printf("<TR>\n");
	printf("<TH> Name </TH> <TH> Port </TH> <TH> Type </TH>\n");
	printf("</TR>\n");
	ports_enum(PORTS_SP,porttable);
	ports_enum(PORTS_WK,porttable);
	ports_enum(PORTS_DB,porttable);
	printf("</TABLE>\n");
	printf("</BODY></HTML>\n");
	
	return(0);
}

