/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*queryaddport.c */
#include <stdio.h>
#include "../lib/defs.h"
#include "ports.h"

int main(int argc,char *argv[])
{
	char str[256],port0[8],port1[8];
	char portname[20],portval[20];
	int p0,p1;

	/* check if password is still valid */
	if(html_system(CHECK_LOGIN)){
		exit(0);
	}

	/* read parameters from stdin */
	fgets(str,256,stdin);
	getparam(str,"name=",portname,20);
	getparam(str,"port0=",port0,8);
	p0=atoi(port0);
	getparam(str,"port1=",port1,8);
	p1=atoi(port1);

	/* check that we did receive a name for the port */
	if(!portname[0]){
		PORTS_ERROR("error_1");
		return(0);
	}

	/* check that a port with this name doesnt exist already */
	if( ports_getportsbyname(PORTS_ALL,portname,NULL,NULL) ){
		PORTS_ERROR("error_5");
		return(0);
	}

	/* evalute portval string */
	if(p1){
		sprintf(portval,"%d:%d",p0,p1);
	}else{
		sprintf(portval,"%d",p0);
	}

	html_title("Query Add Port");
	printf("<BODY>\n");
	printlinks(FWT_LINKS,NULL);
	printf("<H3>Add Port</H3>\n");
	printf("<p>Do you really want to add the port <STRONG>%s [%s]</STRONG>\n",portname,portval);
	printf("to the system ?\n");
	printf("<BR>\n");
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",ADD_PORTS);
	printf("<INPUT TYPE=\"hidden\" NAME=\"name\" VALUE=\"%s\">\n",portname);
	printf("<INPUT TYPE=\"hidden\" NAME=\"port0\" VALUE=\"%d\">\n",p0);
	printf("<INPUT TYPE=\"hidden\" NAME=\"port1\" VALUE=\"%d\">\n",p1);
	printf("<INPUT TYPE=\"submit\" VALUE=\"YES, add %s\">\n",portname);
	printf("</FORM>\n");
	printf("<FORM ACTION=\"%s\" METHOD=GET>\n",RELOAD_PORTS);
	printf("<INPUT TYPE=\"submit\" VALUE=\"CANCEL\">\n");
	printf("</FORM>\n");
	printf("</BODY></HTML>\n");

	return(0);
}

