/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/*querydeleteport.c */
#include <stdio.h>
#include "../lib/defs.h"
#include "ports.h"

int main(int argc,char *argv[])
{
	char str[256];
	char portname[20];

	/* check if password is still valid */
	if(html_system(CHECK_LOGIN)){
		exit(0);
	}

	/* read parameters from stdin */
	fgets(str,256,stdin);
	getparam(str,"selected_port=",portname,20);
	
	/* cannot delete port that is referenced from a rule */
	if( rules_numportrefs(RULES_ALL,portname) ){
		PORTS_ERROR("error_6");
		exit(0);
	}

	html_title("Query Delete Port");
	printf("<BODY>\n");
	printlinks(FWT_LINKS,NULL);
	printf("<H3>Delete Port</H3>\n");
	printf("<p>Do you really want to delete the port <STRONG>%s</STRONG>\n",portname);
	printf("from the system ?\n");
	printf("<BR>\n");
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",DELETE_PORTS);
	printf("<INPUT TYPE=\"hidden\" NAME=\"selected_port\" VALUE=\"%s\">\n",portname);
	printf("<INPUT TYPE=\"submit\" VALUE=\"YES, delete %s\">\n",portname);
	printf("</FORM>\n");
	printf("<FORM ACTION=\"%s\" METHOD=GET>\n",RELOAD_PORTS);
	printf("<INPUT TYPE=\"submit\" VALUE=\"CANCEL\">\n");
	printf("</FORM>\n");
	printf("</BODY></HTML>\n");

	return(0);
}


