/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include "../lib/defs.h"
#include "ppp.h"


int main(int argc,char *argv[])
{
	struct PPPDATA pd;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	html_title("PPP Configuration");
	printf("<BODY>\n");
	printlinks(IFCFG_LINKS,PPP_LINKS);
	printf("<H3>PPP Configuration</H3>\n");
	ppp_getpppdata("ppp0",&pd);

	if( !pd.enabled ){
		printf("<strong>PPP is disabled</strong><br><br>\n");
		printf("<form action=\"%s\" method=post>\n",PPP_QUERYCONFIG);
		printf("<input type=\"submit\" value=\"ENABLE PPP\">\n");
		printf("<br></form>\n");
		printf("</BODY></HTML>\n");
		exit(0);
	}

	printf("PPP is enabled<br>\n");
	printf("PPP is %s connected<br>\n",
		pd.connected?"":"not");
	printf("Device: <strong>%s</strong><br>\n",pd.dev);
	printf("Speed: <strong>%d</strong><br>\n",pd.speed);
	printf("Phone: <strong>%s</strong><br>\n",pd.phone);
	printf("Username: <strong>%s</strong><br>\n",pd.username);
	printf("<br>\n");


	printf("<table><tr><td>\n");
	printf("<form action=\"%s\" method=post>\n",PPP_QUERYCONFIG);
	printf("<input type=\"submit\" value=\"CONFIGURATION\">\n");
	printf("</form>\n");
	printf("</td><td>\n");
	printf("<form action=\"%s\" method=post>\n",PPP_QUERYSECURITY);
	printf("<input type=\"submit\" value=\"SECURITY\">\n");
	printf("</form>\n");
	printf("</td></tr></table>\n");

	printf("<table><tr><td>\n");
	printf("<form action=\"%s\" method=post>\n",PPP_QUERYDISABLE);
	printf("<input type=\"submit\" value=\"DISABLE PPP\">\n");
	printf("</form>\n");
	printf("</td><td>\n");
	if( pd.connected ){
		printf("<form action=\"%s\" method=post>\n",PPP_QUERYDISCONNECT);
		printf("<input type=\"submit\" value=\"DISCONNECT NOW\">\n");
		printf("</form>\n");
	} else {
		printf("<form action=\"%s\" method=post>\n",PPP_QUERYCONNECT);
		printf("<input type=\"submit\" value=\"CONNECT NOW\">\n");
		printf("</form>\n");
	}
	printf("</td></tr></table>\n");

	printf("</BODY></HTML>\n");
	exit(0);
}

