/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include "../lib/defs.h"
#include "ppp.h"


int main(int argc,char *argv[])
{
	struct PPPDATA pd;
	char speed[8];

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

			
	html_title("Configure PPP");
	printf("<BODY>\n");
	printlinks(IFCFG_LINKS,PPP_LINKS);
	printf("<H3>Configure PPP</H3>\n");

	ppp_getpppdata("ppp0",&pd);
	/* should we also configure security ?*/
	if(ppp_checksecurity("ppp0")){
		printf("<form action=\"%s\" method=post>\n",PPP_QUERYSECURITY);
	} else {
		printf("<form action=\"%s\" method=post>\n",PPP_SECURITY);
	}
	/* device */
	printf("<strong>Device:</strong>\n");
	printf("<select name=\"device\">\n");
	option(pd.dev,"ttyS0","ttyS0");
	option(pd.dev,"ttyS1","ttyS1");
	option(pd.dev,"ttyS2","ttyS2");
	option(pd.dev,"ttyS3","ttyS3");
	printf("</select><br><br>\n");
	/* speed */
	sprintf(speed,"%d",pd.speed);
	printf("<strong>Speed:</strong>\n");
	printf("<select name=\"speed\">\n");
	option(speed,"38400","38400");
	option(speed,"28800","28800");
	option(speed,"19200","19200");
	option(speed,"14400","14400");
	option(speed,"9600","9600");
	option(speed,"2400","2400");
	printf("</select><br><br>\n");
	/* phone */
	printf("<strong>Phone# </strong>\n");
	printf("<input type=\"text\" name=\"phone\" value=\"%s\" size=16 maxlength=16>\n",pd.phone);
	printf("<br><br>\n");
	/* username */
	printf("<strong>Username: </strong>\n");
	printf("<input type=\"text\" name=\"username\" value=\"%s\" size=16 maxlength=16>\n",pd.username);
	printf("<br><br>\n");

	/* should we also configure security ?*/
	if(ppp_checksecurity("ppp0")){
		printf("<input type=\"submit\" value=\"CONTINUE\">\n");
	} else {
		printf("<input type=\"submit\" value=\"UPDATE\">\n");
	}
	printf("</form>\n");

	printf("<form action=\"%s\" method=post>\n",PPP_RELOAD);
	printf("<input type=\"submit\" value=\"CANCEL\">\n");
	printf("<br></form>\n");

	printf("</BODY></HTML>\n");
	exit(0);
}

