/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include "../lib/defs.h"
#include "ppp.h"


int main(int argc,char *argv[])
{
	int configure;
	char str[256];
	char device[8];
	char speed[8];
	char username[16];
	char phone[40];
	struct PPPDATA pd;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	/* we might wave got some stuff from config */
	configure=0;
	fgets(str,256,stdin);
	if(!getparam(str,"device=",device,8)){
		configure=1;
		getparam(str,"speed=",speed,8);
		getparam(str,"phone=",phone,40);
		getparam(str,"username=",username,40);
	} else {
		ppp_getpppdata("ppp0",&pd);
		strcpy(username,pd.username);
	}
			
	html_title("Configure PPP Security");
	printf("<BODY>\n");
	printlinks(IFCFG_LINKS,PPP_LINKS);
	printf("<H3>Configure PPP Security</H3>\n");

	printf("<form action=\"%s\" method=post>\n",PPP_SECURITY);
	/* if there were additional data to pass along */
	if(configure){
		printf("<input type=\"hidden\" name=\"device\" value=\"%s\">\n",device);
		printf("<input type=\"hidden\" name=\"speed\" value=\"%s\">\n",speed);
		printf("<input type=\"hidden\" name=\"phone\" value=\"%s\">\n",phone);
	} 
	/* username */
	printf("Username: <strong>%s</strong><br>\n",username);
	printf("<input type=\"hidden\" name=\"username\" value=\"%s\">\n",username);
	/* password */
	printf("Password: \n");
	printf("<input type=\"password\" name=\"password\" size=10 maxlength=10><br><br>\n");

	printf("<input type=\"submit\" value=\"UPDATE\">\n");
	printf("</form>\n");

	printf("<form action=\"%s\" method=post>\n",PPP_RELOAD);
	printf("<input type=\"submit\" value=\"CANCEL\">\n");
	printf("</form>\n");

	printf("</BODY></HTML>\n");
	exit(0);
}

