/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "../lib/defs.h"
#include "ppp.h"

int main(int argc,char *argv[])
{
	struct PPPDATA pd;
	char str[256];
	char device[8];
	char speed[8];
	char phone[40];
	char username[10];
	char password[10];
	FILE *fh;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,256,stdin);
	/* save ppp data */
	if(!getparam(str,"device=",device,8)){
		getparam(str,"speed=",speed,8);
		getparam(str,"phone=",phone,40);
		getparam(str,"username=",username,10);
		strcpy(pd.name,"ppp0");
		pd.speed=atoi(speed);
		strcpy(pd.dev,device);
		strcpy(pd.auth,"pap");
		strcpy(pd.phone,phone);
		strcpy(pd.username,username);
		ppp_savepppdata(&pd);
	}
	ppp_getpppdata("ppp0",&pd);

	/* save security data */
	if(!getparam(str,"password=",password,10)){
		ppp_savesecurity("ppp0",password);
	}


	/* create chat script */
	sprintf(str,"%s/connect.sh",PPPDIR);
	fh=fopen(str,"w");
	fprintf(fh,"#!/bin/sh\n");
	fprintf(fh,"exec chat -v				\\\n");
	fprintf(fh,"	TIMEOUT		3			\\\n");
	fprintf(fh,"	ABORT		'\\nBUSY\\r'		\\\n");
	fprintf(fh,"	ABORT		'\\nNO ANSWER\\r'	\\\n");
	fprintf(fh,"	ABORT		'\\nRINGING\\r\\n\\r\\nRINGING\\r' \\\n");
	fprintf(fh,"	''		\\rATH			\\\n");
	fprintf(fh,"	'OK-+++\\c-OK'	ATH0			\\\n");
	fprintf(fh,"	TIMEOUT		30			\\\n");
	fprintf(fh,"	OK		ATZ			\\\n");
	fprintf(fh,"	OK		ATDT%s			\\\n",pd.phone);
	fprintf(fh,"	CONNECT		''	\n");
	fclose(fh);
	chown(str,0,0);
	chmod(str,S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
	
	/* create ppp options file */
	sprintf(str,"%s/options",PPPDIR);
	fh=fopen(str,"w");
	fprintf(fh,"/dev/%s %d connect \"%s/connect.sh\" user %s crtscts asyncmap 0x00000000 lock noipdefault defaultroute\n",
		pd.dev,pd.speed,PPPDIR,pd.username);
	fclose(fh);
	chown(str,0,0);
	chmod(str,S_IRUSR|S_IWUSR);

	/* create ip-up file */
	sprintf(str,"%s/ip-up",PPPDIR);
	fh=fopen(str,"w");
	fprintf(fh,"#!/bin/sh\n");
	fprintf(fh,"/bin/echo \"`/bin/date +\"%%Y-%%m-%%d %%H:%%M:%%S\"` Connected to %s\" >>%s\n",pd.phone,PPPLOG);
	fprintf(fh,"%s start\n",FWT_RC_FILE);
	fclose(fh);
	chown(str,0,0);
	chmod(str,S_IRUSR|S_IWUSR|S_IXUSR);

	/* create ip-down file */
	sprintf(str,"%s/ip-down",PPPDIR);
	fh=fopen(str,"w");
	fprintf(fh,"#!/bin/sh\n");
	fprintf(fh,"/bin/echo `/bin/date +\"%%Y-%%m-%%d %%H:%%M:%%S\"` Disconnect >>%s\n",PPPLOG);
	/*fprintf(fh,"%s stop\n",FWT_RC_FILE);*/
	fclose(fh);
	chown(str,0,0);
	chmod(str,S_IRUSR|S_IWUSR|S_IXUSR);

	
	html_system(PPP_RELOAD);
	exit(0);
}

