/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "../lib/defs.h"
#include "redir.h"


int main(int argc,char *argv[])
{
	char str[256];
	char iface[16];
	char port[16];

	/* check if password is still valid */
	if(html_system(CHECK_LOGIN)){
		exit(0);
	}

	/* read parameters from stdin */
	fgets(str,256,stdin);
	getparam(str,"add_if=",iface,16);
	getparam(str,"add_port=",port,16);

	/* check that the redir doesnt already exist */
	if(redir_getmarkbyredir(iface,port)){
		REDIR_ERROR("error_1");
		exit(0);
	}

	/* redir can only fail if too many of them exists */
	if(!redir_create(iface,port)){
		REDIR_ERROR("error_2");
		exit(0);
	}

	html_system(RELOAD_REDIRECT);
	return(0);
}

