/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include "../lib/defs.h"
#include "redir.h"

int main(int argc,char *argv[])
{
	char str[1024];
	char tmp[16];
	char target[24];
	char port[16];
	int mark;
	struct REDIR *rd;

	/* check if password is still valid */
	if(html_system(CHECK_LOGIN)){
		exit(0);
	}

	/* read parameters from stdin */
	fgets(str,256,stdin);
	getparam(str,"redirection=",tmp,16);
	getparam(str,"target=",target,24);
	getparam(str,"port=",port,16);
	mark=atoi(tmp);
	rd=redir_getredirbymark(mark);

	html_title("Add TCP Redirection Target");
	printf("<BODY>\n");
	printlinks(REDIR_LINKS,NULL);
	printf("<H3>Add TCP Redirection Target</H3>\n");
	printf("<PRE>Do you really want to add this target\n");
	printf("Target:<STRONG>%s</STRONG> Port:<STRONG>%s</STRONG>\n",target,port);
	printf("to the redirection for the port\n");
	printf("Iface:<STRONG>%s</STRONG>\n",rd->iface);
	printf("Port: <STRONG>%s</STRONG>\n",rd->port);
	printf("</PRE><BR>\n");
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",ADDTARGET);
	printf("<INPUT TYPE=\"hidden\" NAME=\"redirection\" VALUE=\"%d\">\n",mark);
	printf("<INPUT TYPE=\"hidden\" NAME=\"target\" VALUE=\"%s\">\n",target);
	printf("<INPUT TYPE=\"hidden\" NAME=\"port\" VALUE=\"%s\">\n",port);
	printf("<INPUT TYPE=\"submit\" VALUE=\"YES, ADD THIS TARGET\">\n");
	printf("</FORM>\n");
	printf("<FORM ACTION=\"%s\" METHOD=GET>\n",RELOAD_REDIRECT);
	printf("<INPUT TYPE=\"submit\" VALUE=\"CANCEL\">\n");
	printf("</FORM>\n");
	printf("</BODY></HTML>\n");

	return(0);
}
