/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include "../lib/defs.h"
#include "redir.h"

int listtarget(struct REDIR_TARGET *target)
{
	printf("<STRONG>%s</STRONG>\n",target->host);
	return(0);
}

int main(int argc,char *argv[])
{
	char str[1024];
	char tmp[16];
	int mark;
	struct REDIR *rd;

	/* check if password is still valid */
	if(html_system(CHECK_LOGIN)){
		exit(0);
	}

	/* read parameters from stdin */
	fgets(str,256,stdin);
	getparam(str,"del_redir=",tmp,16);
	mark=atoi(tmp);
	rd=redir_getredirbymark(mark);

	html_title("Delete TCP Redirection");
	printf("<BODY>\n");
	printlinks(REDIR_LINKS,NULL);
	printf("<H3>Delete TCP Redirection</H3>\n");
	printf("<p>Do you really want to delete this redirection \n");
	printf("from the system ?\n");
	printf("<PRE>Iface:<STRONG>%s</STRONG>\n",rd->iface);
	printf("Port: <STRONG>%s</STRONG>\n",rd->port);
	if(redir_targetenum(mark,NULL)){
		printf("which is redirected to the following target(s):\n");
		redir_targetenum(mark,listtarget);
	}
	printf("</PRE><BR>\n");
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",DELPORT);
	printf("<INPUT TYPE=\"hidden\" NAME=\"del_redir\" VALUE=\"%d\">\n",mark);
	printf("<INPUT TYPE=\"submit\" VALUE=\"YES, DELETE THIS REDIRECT\">\n");
	printf("</FORM>\n");
	printf("<FORM ACTION=\"%s\" METHOD=GET>\n",RELOAD_REDIRECT);
	printf("<INPUT TYPE=\"submit\" VALUE=\"CANCEL\">\n");
	printf("</FORM>\n");
	printf("</BODY></HTML>\n");

	return(0);
}

