/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include "../lib/defs.h"
#include "redir.h"

int main(int argc,char *argv[])
{
	char str[1024];
	char tmp[64];
	char *target;
	char *port;
	int mark,count;
	struct REDIR *rd;

	/* check if password is still valid */
	if(html_system(CHECK_LOGIN)){
		exit(0);
	}

	/* read parameters from stdin */
	fgets(str,256,stdin);
	getparam(str,"target=",tmp,64);
	target=index(tmp,':');*target++=0;
	port=index(target,':');*port++=0;
	sscanf(tmp,"%d",&mark);
	rd=redir_getredirbymark(mark);

	html_title("Delete TCP Redirection Target");
	printf("<BODY>\n");
	printlinks(REDIR_LINKS,NULL);
	printf("<H3>Delete TCP Redirection Target</H3>\n");
	printf("<PRE>Do you really want to delete this target\n");
	printf("Target:<STRONG>%s</STRONG> Port:<STRONG>%s</STRONG>\n",
		target,port);
	printf("from the redirection for the port\n");
	printf("Iface:<STRONG>%s</STRONG>\n",rd->iface);
	printf("Port: <STRONG>%s</STRONG>\n",rd->port);
	printf("</PRE><BR>\n");
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",DELTARGET);
	printf("<INPUT TYPE=\"hidden\" NAME=\"target\" VALUE=\"%d:%s:%s\">\n",mark,target,port);
	printf("<INPUT TYPE=\"submit\" VALUE=\"YES, DELETE THIS TARGET\">\n");
	printf("</FORM>\n");
	printf("<FORM ACTION=\"%s\" METHOD=GET>\n",RELOAD_REDIRECT);
	printf("<INPUT TYPE=\"submit\" VALUE=\"CANCEL\">\n");
	printf("</FORM>\n");
	printf("</BODY></HTML>\n");

	return(0);
}

