/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include "../lib/defs.h"
#include "redir.h"

int listtarget(char *name,char *type,char *val)
{
	int a0,a1,a2,a3,nm;
	sscanf(val,"%d.%d.%d.%d/%d",&a0,&a1,&a2,&a3,&nm);
	if(nm!=32)
		return(0);
	printf("<OPTION VALUE=\"%s\">%s\n",name,name);
	return(0);
}

unsigned char iface[16];
unsigned char port[16];
int targettable(struct REDIR_TARGET *target)
{
	printf("<TR><TD>%s</TD><TD>%s</TD><TD>%s</TD><TD>%s</TD></TR>\n",
		iface,port,target->host,target->port);
	iface[0]=port[0]=0;
	return(0);
}
int redirtable(struct REDIR *redir)
{
	strcpy(iface,redir->iface);
	strcpy(port,redir->port);
	redir_targetenum(redir->mark,targettable);
	/* if there were no targets, yet ?*/
	if(iface[0]){
		printf("<TR><TD>%s</TD><TD>%s</TD><TD></TD><TD></TD></TR>\n",
			iface,port);
	}
	return(0);
}

struct REDIR *rd;
static int count;
int listt(struct REDIR_TARGET *target)
{
	printf("<OPTION VALUE=\"%d:%s:%s\">IF:%s PORT:%s --> HOST:%s:%s\n",
		target->mark,
		target->host,
		target->port,
		rd->iface,
		rd->port,
		target->host,
		target->port);
	count++;
	return(0);
}
int listrt(struct REDIR *redir)
{
	rd=redir;
	count=0;
	redir_targetenum(redir->mark,listt);
	return(0);
}

int listredir(struct REDIR *redir)
{
	printf("<OPTION VALUE=\"%d\">IF:%s PORT:%s\n",redir->mark,redir->iface,redir->port);
	return(0);
}

int listports(char *port,char *type,int port1,int port2)
{
	if(!strcmp(port,"ALL"))
		return(0);
	/* only single port entries */
	if(port2==0){
			printf("<OPTION VALUE=\"%s\">%s\n",port,port);
	}
	return(0);
}

int listifgroups(char *name,char *type,char *val)
{
	if(strncmp("eth",name,3)){
		return(0);
	}
	printf("<OPTION VALUE=\"%s\">%s\n",name,name);
	return(0);
}

int main(int argc,char *argv[])
{

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	html_title("TCP Redirection");
	printf("<BODY>\n");
	printlinks(REDIR_LINKS,NULL);
	printf("<H3>TCP Redirection</H3>\n");

	/* add redirection */
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_ADDPORT);
	printf("Interface:");
	printf("<SELECT NAME=\"add_if\">\n");
	groups_enum(GROUPS_IF,listifgroups);
	printf("</SELECT>\n");
	printf("Port:");
	printf("<SELECT NAME=\"add_port\">\n");
	ports_enum(PORTS_ALL,listports);
	printf("</SELECT>\n");
	printf("<INPUT TYPE=\"submit\" VALUE=\"REDIRECT PORT\">\n");
	printf("</FORM>\n");

	/* delete redirection, if there are any to delete ! */
	if(redir_enum(NULL)){
		printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_DELPORT);
		printf("<SELECT NAME=\"del_redir\">\n");
		redir_enum(listredir);
		printf("</SELECT>\n");
		printf("<INPUT TYPE=\"submit\" VALUE=\"DELETE REDIRECTION\">\n");
		printf("</FORM>\n");
	}

	/* add target if there are any redirections */
	if(redir_enum(NULL)){
		printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_ADDTARGET);
		printf("<SELECT NAME=\"redirection\">\n");
		redir_enum(listredir);
		printf("</SELECT>\n");
		printf(" Target:");
		printf("<SELECT NAME=\"target\">\n");
		groups_enum(GROUPS_DB,listtarget);
		printf("</SELECT>\n");
		printf(" Port:");
		printf("<SELECT NAME=\"port\">\n");
		ports_enum(PORTS_ALL,listports);
		printf("</SELECT>\n");
		printf("<INPUT TYPE=\"submit\" VALUE=\"ADD TARGET\">\n");
		printf("</FORM>\n");
	}

	/* delete target if there are any */
	if(redir_targetenum(-1,NULL)){
		printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_DELTARGET);
		printf("<SELECT NAME=\"target\">\n");
		redir_enum(listrt);
		printf("</SELECT>\n");
		printf("<INPUT TYPE=\"submit\" VALUE=\"DELETE TARGET\">\n");
		printf("</FORM>\n");
	}
	
	/* table */
	printf("<TABLE BORDER>\n");
	printf("<CAPTION><STRONG>Current Redirections</STRONG></CAPTION>\n");
	printf("<TR>");
	printf("<TH>Iface</TH>");
	printf("<TH>Port</TH>");
	printf("<TH>Redirected to</TH>");
	printf("<TH>Port</TH>");
	printf("</TR>\n");
	redir_enum(redirtable);	
	printf("</TABLE>\n");

	printf("</BODY></HTML>\n");
	return(0);
}

