/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include "../lib/defs.h"
#include "route.h"

int main(int argc,char *argv[])
{
	char str[256];
	char target[16];
	char gateway[16];
	char *grp;
	char *type;
	char *iface;
	int a0,a1,a2,a3,nm;

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,256,stdin);
	getparam(str,"target=",target,16);
	getparam(str,"gateway=",gateway,16);


	if(target[0]==0){
		ROUTE_ERROR("error_3");
		exit(0);
	}
	if(gateway[0]==0){
		ROUTE_ERROR("error_4");
		exit(0);
	}

	/* determine type of target */
	if(!strcmp(target,"default")){
		type="default";
	} else {
		grp=groups_getgroupvalbyname(GROUPS_ALL,target);
		if(!grp){
			ROUTE_ERROR("error_5");
			exit(0);
		}
		sscanf(grp,"%d.%d.%d.%d/%d",&a0,&a1,&a2,&a3,&nm);
		if(nm==32){
			type="host";
		} else {
			type="net";
		}
	}

	if( route_getroutebytarget(target) ){
		if( !strcmp(target,"default") ){
			/* you can only have one default route */
			ROUTE_ERROR("error_1");
			exit(0);
		}
		ROUTE_ERROR("error_2");
		exit(0);
	}
	/* determine which interface the route would use */
	if( (iface=route_getgroupiface(gateway))==NULL ){
		ROUTE_ERROR("error_6");
		exit(0);
	}

	html_title("Add Route");
	printf("<BODY>\n");
	printlinks(IFCFG_LINKS,ROUTE_LINKS);
	printf("<H3>Add Route</H3>\n");

	printf("Do you really want to add this route?<br>\n");
	if(!strcmp(target,"default")){
		printf("Target : <strong>default route</strong><br>\n");
	} else {
		printf("Target : <strong>%s</strong>  Type :<strong>%s</strong><br>\n",target,type);
	}
	printf("Gateway: <strong>%s</strong><br>\n",gateway);
	printf("Iface  : <strong>%s</strong><br>\n",iface);

	printf("<form action=\"%s\" method=post>\n",ROUTEADD);
	printf("<input type=hidden name=target value=\"%s\">\n",target);
	printf("<input type=hidden name=gateway value=\"%s\">\n",gateway);
	printf("<input type=submit value=\"YES, ADD THIS ROUTE\">\n");
	printf("<br></form>\n");

	printf("<form action=\"%s\" method=post>\n",ROUTERELOAD);
	printf("<input type=submit value=\"CANCEL\">\n");
	printf("<br></form>\n");
	
	printf("</BODY></HTML>\n");
	exit(0);
}

