/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <string.h>
#include "../lib/defs.h"
#include "route.h"

int initroutetable(void)
{
	printf("<table border>\n");
	printf("<caption><strong>Routing Table</strong></caption>\n");
	printf("<tr>");
	printf("<th>Target</th>");
	printf("<th>Type</th>");
	printf("<th>Gateway</th>");
	printf("<th>Iface</th>");
	printf("<th></th>");
	printf("</tr>\n");
	return(0);
}
int listroute(char *typename,struct STROUTE *stroute)
{
	printf("<tr>");
	printf("<td>%s</td>",stroute->target);
	printf("<td>%s</td>",stroute->ttype);
	printf("<td>%s</td>",stroute->gateway);
	printf("<td>%s</td>",stroute->iface);
	printf("<td>%s</td>",typename);
	printf("</tr>\n");
	return(0);
}
int endroutetable(void)
{
	printf("</table>\n");
	return(0);
}

int listdeleteroute(char *typename,struct STROUTE *stroute)
{
	printf("<option value=\"%s\">%s %s %s %s",
		stroute->target,
		stroute->target,stroute->ttype,
		stroute->gateway,stroute->iface);
	return(0);
}

int listaddtarget(char *name,char *type,char *val)
{
	int a0,a1,a2,a3,nm;
	char *tt;
	char tmpname[32];

	sscanf(val,"%d.%d.%d.%d/%d",&a0,&a1,&a2,&a3,&nm);
	if(nm==32) tt="host";
	else       tt="net ";	

	/* target must not belong to a subnet we are connected to */
	strcpy(tmpname,name);
	if(route_numlocalroutestogroup(tmpname)==0){
		printf("<option value=\"%s\">%s : %s\n",tmpname,tt,tmpname);
	}
	return(0);
}

int listaddroute(char *name,char *type,char *val)
{
	printf("<option value=\"%s\">%s\n",name,name);
	return(0);
}

int main(int argc,char *argv[])
{
	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	html_title("Standard Routing");
	printf("<BODY>\n");
	printlinks(IFCFG_LINKS,ROUTE_LINKS);
	printf("<H3>Standard Routing</H3>\n");

/*XXXX ADD only available when both targets and routers exist */
	/* add route */
	printf("<form action=\"%s\" method=post>\n",ROUTEQUERYADD);
	printf("<strong>Target:</strong>\n");
	printf("<select name=\"target\">\n");
	printf("<option value=\"default\">default\n");
	groups_enum(GROUPS_DB,listaddtarget);
	printf("</select>\n");
	printf("<strong>Gateway:</strong>\n");
	printf("<select name=\"gateway\">\n");
	groups_enum(GROUPS_LLH,listaddroute);
	printf("</select>\n");
	printf("<input type=submit value=\"ADD ROUTE\">\n");
	printf("<br></form>\n");

	/* delete route */
	if(route_num(ROUTES_USR)){
		printf("<form action=\"%s\" method=post>\n",ROUTEQUERYDELETE);
		printf("<select name=\"target\">\n");
		route_enum(ROUTES_USR,listdeleteroute);
		printf("</select>\n");
		printf("<input type=submit value=\"DELETE ROUTE\">\n");
		printf("<br></form>\n");
	}

	initroutetable();
	route_enum(ROUTES_ALL,listroute);
	endroutetable();

	printf("</BODY></HTML>\n");
	exit(0);
}

