/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../lib/defs.h"
#include "rules.h"

int main(int argc,char *argv[])
{
	char str[256];
	char ruleset[20];
	char rulepos[20];
	int type,pos;
	struct RULE rule;

	if(html_system(CHECK_LOGIN)){
		return(10);
	}

	fgets(str,256,stdin);
	getparam(str,"selected_rule=",rulepos,20);
	pos=atoi(rulepos);
	rules_httptorule(str,&rule);

	type=RULES_ALL;
	getparam(str,"ruleset=",ruleset,20);
	if(!strcmp("input",ruleset))
		type=RULES_IN;
	if(!strcmp("output",ruleset))
		type=RULES_OU;
	if(!strcmp("forward",ruleset))
		type=RULES_FW;
	if(type==RULES_ALL)
		exit(10);

	/* check sanity of rules */
	if( strcmp(rule.srcport,"ALL") || strcmp(rule.dstport,"ALL") ){
		if( strncmp(rule.protocol,"tcp",3) && strcmp(rule.protocol,"udp") ){
			RULES_ERROR("error_3",ruleset);
			return(10);
		}
	}

	rules_delrule(type,pos);
	rules_addrule(type,pos,&rule);

	sprintf(str,"/bin/echo \"ruleset=%s\" | %s/%s",
		ruleset,TOPDIR,RELOAD_RULES);
	system(str);

	return(0);
}
	
