/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../lib/defs.h"
#include "rules.h"

int main(int argc,char *argv[])
{
	int i;
	char str[256];
	char ruleset[20],rulepos[5];
	struct RULE rule;

	if(html_system(CHECK_LOGIN)){
		return(10);
	}

	fgets(str,256,stdin);
	getparam(str,"ruleset=",ruleset,20);
	getparam(str,"selected_rule=",rulepos,5);
	rules_httptorule(str,&rule);

	i=atoi(rulepos);
	if( i<0 ){
		RULES_ERROR("error_1",ruleset);
		return(10);
	}

	/*everything seems OK, query the user if he wants to add it*/
	printf("Refresh: %d; URL=\"%s\"\n",LOGIN_TIMEOUT,LOGOUT);
	printf("Content-Type: text/html\n");
	printf("\n");
	printf("<HTML><HEAD>\n");
	printf("<TITLE>Query Add %s Rule</TITLE></HEAD>\n",ruleset);
	printf("<BODY>\n");
	printlinks(FWT_LINKS,RULE_LINKS);
	printf("<H3>Add %s Rule</H3>\n",ruleset);
	printf("<p>Do you really want to add this rule to the system ?\n");
	printf("<BR>\n");
	printf("<PRE>\n");
	printf("<STRONG>Pos:%d</STRONG>\n",i);
	printf("Action: %s\n",rule.action);
	printf("Protocol: %s\n",rule.protocol);
	printf("Interface: %s\n",rule.iface);
	if( !strncmp(rule.protocol,"tcp",3) || !strcmp(rule.protocol,"udp") ){
		printf("Source IP: %s  Ports: %s\n",rule.srcip,rule.srcport);
		printf("Dest   IP: %s  Ports: %s\n",rule.dstip,rule.dstport);
	} else {
		printf("Source IP: %s\n",rule.srcip);
		printf("Dest   IP: %s\n",rule.dstip);
	}
	if( !strcmp(rule.protocol,"icmp") ){
		printf("ICMP Type: %s\n",rule.icmptype);
		printf("ICMP Code: %s\n",rule.icmpcode);
	}
	printf("</PRE>\n");
	printf("<BR>\n");

	/* The ADD button */
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",ADD_RULE);
	printf("<INPUT TYPE=\"hidden\" NAME=\"ruleset\" VALUE=\"%s\">\n",ruleset);
	printf("<INPUT TYPE=\"hidden\" NAME=\"selected_rule\" VALUE=\"%d\">\n",i);
	rules_printashtml(&rule);
	printf("<INPUT TYPE=\"submit\" VALUE=\"YES, add this rule\">\n");
	printf("</FORM>\n");

	/* cancel button */
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",RELOAD_RULES);
	printf("<INPUT TYPE=\"hidden\" NAME=\"ruleset\" VALUE=\"%s\">\n",ruleset);
	printf("<INPUT TYPE=\"submit\" VALUE=\"CANCEL\">\n");
	printf("</FORM>\n");

	printf("</BODY></HTML>\n");
	return(0);
}


