/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../lib/defs.h"
#include "rules.h"

char *listifselected;
int listif(char *iface,char *type,char *value)
{
	char *str;
	if(strcmp(listifselected,iface))str="";
	else str="SELECTED";
	printf("<OPTION %s VALUE=\"%s\">%s\n",str,iface,iface);
	return(0);
}

char *listportselected;
int listport(char *iface,char *type,int port1,int port2)
{
	char *str;
	if(strcmp(listportselected,iface))str="";
	else str="SELECTED";
	printf("<OPTION %s VALUE=\"%s\">%s\n",str,iface,iface);
	return(0);
}
char *listicmptypeselected;
int listicmptype(char *name,char *value)
{
	char *str;
	if(strcmp(listicmptypeselected,value))str="";
	else str="SELECTED";
	printf("<OPTION %s VALUE=\"%s\">%s\n",str,value,name);
	return(0);
}
char *listicmpcodeselected;
int listicmpcode(char *name,char *value)
{
	char *str;
	if(strcmp(listicmpcodeselected,value))str="";
	else str="SELECTED";
	printf("<OPTION %s VALUE=\"%s\">%s\n",str,value,name);
	return(0);
}

int main(int argc,char *argv[])
{
	int type,pos;
	char str[256];
	char ruleset[20],rulepos[5];
	struct RULE *rule;

	if(html_system(CHECK_LOGIN)){
		return(10);
	}

	fgets(str,256,stdin);
	getparam(str,"ruleset=",ruleset,20);
	getparam(str,"selected_rule=",rulepos,20);
	pos=atoi(rulepos);
	if(!strcmp(ruleset,"input"))
		type=RULES_IN;
	if(!strcmp(ruleset,"output"))
		type=RULES_OU;
	if(!strcmp(ruleset,"forward"))
		type=RULES_FW;

	if( pos<0 ){
		RULES_ERROR("error_1",ruleset);
		return(10);
	}
	rule=rules_getrulebyindex(type,pos);

	/*everything seems OK, query the user if he wants to add it*/
	printf("Refresh: %d; URL=\"%s\"\n",LOGIN_TIMEOUT,LOGOUT);
	printf("Content-Type: text/html\n");
	printf("\n");
	printf("<HTML><HEAD>\n");
	printf("<TITLE>Query Edit %s Rule</TITLE></HEAD>\n",ruleset);
	printf("<BODY>\n");
	printlinks(FWT_LINKS,RULE_LINKS);
	printf("<H3>Edit %s Rule</H3>\n",ruleset);


	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",EDIT_RULE);
	/* action */
	printf("<STRONG>Action:</STRONG>\n");
	printf("<SELECT NAME=\"action\">\n");
	option(rule->action,"ACCEPT","Accept");
	if(!strcmp(ruleset,"forward"))
		option(rule->action,"MASQ","Masquerade");
	option(rule->action,"REJECT","Reject");
	option(rule->action,"REJECTLOG","Reject+Log");
	option(rule->action,"DENY","Deny");
	option(rule->action,"DENYLOG","Deny+Log");
	printf("</SELECT>\n");

	/* protocol */
	printf("<STRONG>Protocol:</STRONG>\n");
	printf("<SELECT NAME=\"protocol\">\n");
	option(rule->protocol,"ALL","ALL");
	option(rule->protocol,"tcp","Tcp");
	option(rule->protocol,"tcpsyn","Tcp+Syn");
	option(rule->protocol,"udp","Udp");
	option(rule->protocol,"icmp","Icmp");
	option(rule->protocol,"frag","IP Fragment");
	printf("</SELECT>\n");

	/* iface */
	printf("<STRONG>Iface:</STRONG>\n");
	printf("<SELECT NAME=\"iface\">\n");
	listifselected=rule->iface;
	listif("ALL",NULL,NULL);
	groups_enum(GROUPS_IF,listif);
	printf("</SELECT>\n");
	printf("<BR>\n");

	/* SRC IP address */
	printf("<STRONG>SRC-IP:</STRONG>\n");
	printf("<SELECT NAME=\"srcip\">\n");
	listifselected=rule->srcip;
	groups_enum(GROUPS_ALL,listif);
	printf("</SELECT>\n");

	/* SRC port */
	printf("<STRONG>Ports:</STRONG>\n");
	printf("<SELECT NAME=\"srcport\">\n");
	listportselected=rule->srcport;
	ports_enum(PORTS_ALL,listport);
	printf("</SELECT>\n");

	/* ICMP Type */
	printf("<strong>ICMP Type:</strong>\n");
	printf("<select name=\"icmptype\">\n");
	listicmptypeselected=rule->icmptype;
	icmp_typeenum(listicmptype);
	printf("</select>\n");
	printf("<BR>\n");

	/* DST IP address */
	printf("<STRONG>DST-IP:</STRONG>\n");
	printf("<SELECT NAME=\"dstip\">\n");
	listifselected=rule->dstip;
	groups_enum(GROUPS_ALL,listif);
	printf("</SELECT>\n");

	/* DST port */
	printf("<STRONG>Ports:</STRONG>\n");
	printf("<SELECT NAME=\"dstport\">\n");
	listportselected=rule->dstport;
	ports_enum(PORTS_ALL,listport);
	printf("</SELECT>\n");

	/* ICMP Code */
	printf("<strong>ICMP Code:</strong>\n");
	printf("<select name=\"icmpcode\">\n");
	listicmpcodeselected=rule->icmpcode;
	icmp_codeenum(listicmpcode);
	printf("</select>\n");
	printf("<BR>\n");

	printf("<INPUT TYPE=\"submit\" VALUE=\"OK UPDATE RULE\">\n");
	printf("<INPUT TYPE=\"hidden\" NAME=\"selected_rule\" VALUE=\"%d\">\n",pos);
	printf("<INPUT TYPE=\"hidden\" NAME=\"ruleset\" VALUE=\"%s\">\n",ruleset);
	printf("</FORM>\n");


	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",RELOAD_RULES);
	printf("<INPUT TYPE=\"hidden\" NAME=\"ruleset\" VALUE=\"%s\">\n",ruleset);
	printf("<INPUT TYPE=\"submit\" VALUE=\"CANCEL\">\n");
	printf("</FORM>\n");

	printf("</BODY></HTML>\n");
	return(0);
}

