/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* rules_test.c */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "../lib/defs.h"
#include "rules.h"

static FILE *fh;
static char str[512];
static char cmd[1024];
static char iface[16];
static char ruleset[16];
static char protocol[16];
static char s0[4],s1[4],s2[4],s3[4],sp[6];
static char d0[4],d1[4],d2[4],d3[4],dp[6];
static char srcip[20],srcport[10];
static char dstip[20],dstport[10];

int main(int argc,char *argv[])
{
	char proto[16];

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,512,stdin);
	getparam(str,"ruleset=",ruleset,16);
	getparam(str,"iface=",iface,16);
	getparam(str,"protocol=",protocol,16);
	getparam(str,"s0=",s0,4);
	getparam(str,"s1=",s1,4);
	getparam(str,"s2=",s2,4);
	getparam(str,"s3=",s3,4);
	getparam(str,"sp=",sp,6);
	getparam(str,"d0=",d0,4);
	getparam(str,"d1=",d1,4);
	getparam(str,"d2=",d2,4);
	getparam(str,"d3=",d3,4);
	getparam(str,"dp=",dp,6);

	html_title("FWT Test Rule Result");
	printf("<BODY>\n");
	printlinks(FWT_LINKS,RULE_LINKS);
	printf("<H3>Test Rule Result</H3>\n");
	
	printf("<PRE>\n");
	printf("Test of ruleset : <STRONG>%s</STRONG>\n",ruleset);
	if(!strcmp(ruleset,"input")){
		printf("Packet received on interface <STRONG>%s</STRONG>\n",iface);
	}
	if(!strcmp(ruleset,"output")){
		printf("Packet transmitted by interface <STRONG>%s</STRONG>\n",iface);
	}
	if(!strcmp(ruleset,"forward")){
		printf("Packet forwarded to interface <STRONG>%s</STRONG>\n",iface);
	}
	printf("Protocol : <STRONG>%s</STRONG>\n",protocol);
	printf("Src IP : <STRONG>%d.%d.%d.%d</STRONG> Port : <STRONG>%d</STRONG>\n",atoi(s0),atoi(s1),atoi(s2),atoi(s3),atoi(sp));
	printf("Dst IP : <STRONG>%d.%d.%d.%d</STRONG> Port : <STRONG>%d</STRONG>\n",atoi(d0),atoi(d1),atoi(d2),atoi(d3),atoi(dp));
	fflush(stdout);

	/* check the rule */
	sprintf(srcip,"%d.%d.%d.%d/32",atoi(s0),atoi(s1),atoi(s2),atoi(s3));
	sprintf(srcport,"%d",atoi(sp));
	sprintf(dstip,"%d.%d.%d.%d/32",atoi(d0),atoi(d1),atoi(d2),atoi(d3));
	sprintf(dstport,"%d",atoi(dp));

	if( !strcmp(protocol,"tcpsyn") ){
		strcat(proto,"tcp -y ");
	} else {
		strcat(proto,protocol);
	}
	sprintf(cmd,"%s -C %s -p %s -i %s -s %s %s -d %s %s",
		IPCHAINS,ruleset,proto,iface,srcip,srcport,dstip,dstport);

	fflush(stdout);
	if(fh=popen(cmd,"r")){
		while(!feof(fh)){
			str[0]=0;
			fgets(str,512,fh);
			if(strlen(str)){
				str[strlen(str)-1]=0;
				printf("<BIG><STRONG>%s</STRONG></BIG>\n",str);
				fflush(stdout);
			}
		}
		pclose(fh);
	}
	fflush(stdout);

	printf("</PRE>\n");
	printf("<BR>\n");

	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",TEST_RULES);
	printf("<INPUT TYPE=\"hidden\" NAME=\"ruleset\" VALUE=\"%s\">\n",ruleset);
	printf("<INPUT TYPE=\"hidden\" NAME=\"iface\" VALUE=\"%s\">\n",iface);
	printf("<INPUT TYPE=\"hidden\" NAME=\"protocol\" VALUE=\"%s\">\n",protocol);
	printf("<INPUT TYPE=\"hidden\" NAME=\"s0\" VALUE=\"%d\">\n",atoi(s0));
	printf("<INPUT TYPE=\"hidden\" NAME=\"s1\" VALUE=\"%d\">\n",atoi(s1));
	printf("<INPUT TYPE=\"hidden\" NAME=\"s2\" VALUE=\"%d\">\n",atoi(s2));
	printf("<INPUT TYPE=\"hidden\" NAME=\"s3\" VALUE=\"%d\">\n",atoi(s3));
	printf("<INPUT TYPE=\"hidden\" NAME=\"sp\" VALUE=\"%d\">\n",atoi(sp));
	printf("<INPUT TYPE=\"hidden\" NAME=\"d0\" VALUE=\"%d\">\n",atoi(d0));
	printf("<INPUT TYPE=\"hidden\" NAME=\"d1\" VALUE=\"%d\">\n",atoi(d1));
	printf("<INPUT TYPE=\"hidden\" NAME=\"d2\" VALUE=\"%d\">\n",atoi(d2));
	printf("<INPUT TYPE=\"hidden\" NAME=\"d3\" VALUE=\"%d\">\n",atoi(d3));
	printf("<INPUT TYPE=\"hidden\" NAME=\"dp\" VALUE=\"%d\">\n",atoi(dp));

	printf("<INPUT TYPE=\"submit\" VALUE=\"Continue\">\n");
	printf("</FORM>\n");

	printf("</BODY></HTML>\n");
	return(0);
}	

