/*
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *
 * Author:	Ronnie Sahlberg <ronnie.sahlberg@mbox301.swipnet.se>
 * Changes:
 */

/* rules_test.c */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "../lib/defs.h"
#include "rules.h"

static char iface[16];

int listif(char *name,char *type,char *value)
{
	option(iface,name,name);
	return(0);
}
	
int main(int argc,char *argv[])
{
	char str[512];
	char ruleset[16];
	char protocol[16];
	char s0[4],s1[4],s2[4],s3[4],sp[6];
	char d0[4],d1[4],d2[4],d3[4],dp[6];

	if(html_system(CHECK_LOGIN)){
		exit(10);
	}

	fgets(str,512,stdin);
	getparam(str,"ruleset=",ruleset,16);
	getparam(str,"iface=",iface,16);
	getparam(str,"protocol=",protocol,16);
	getparam(str,"s0=",s0,4);
	getparam(str,"s1=",s1,4);
	getparam(str,"s2=",s2,4);
	getparam(str,"s3=",s3,4);
	getparam(str,"sp=",sp,6);if(!atoi(sp))strcpy(sp,"1");
	getparam(str,"d0=",d0,4);
	getparam(str,"d1=",d1,4);
	getparam(str,"d2=",d2,4);
	getparam(str,"d3=",d3,4);
	getparam(str,"dp=",dp,6);if(!atoi(dp))strcpy(dp,"1");

	html_title("FWT Test Rule");
	printf("<BODY>\n");
	printlinks(FWT_LINKS,RULE_LINKS);
	printf("<H3>Test Rules</H3>\n");
	
	printf("<FORM ACTION=\"%s\" METHOD=POST>\n",QUERY_TEST_RULE);

	printf("<STRONG>Ruleset :</STRONG>\n");
	printf("<SELECT NAME=\"ruleset\">\n");
	option(ruleset,"input","input");
	option(ruleset,"output","output");
	option(ruleset,"forward","forward");
	printf("</SELECT>\n");
	printf("<BR>\n");

	printf("<STRONG>Interface :</STRONG>\n");
	printf("<SELECT NAME=\"iface\">\n");
	groups_enum(GROUPS_IF,listif);
	printf("</SELECT>\n");
	printf("<BR>\n");

	printf("<STRONG>Protocol :</STRONG>\n");
	printf("<SELECT NAME=\"protocol\">\n");
	option(protocol,"tcp","tcp");
	option(protocol,"tcpsyn","tcpsyn");
	option(protocol,"udp","udp");
	printf("</SELECT>\n");
	printf("<BR>\n");

	printf("<STRONG>Source IP :</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"s0\" VALUE=\"%d\" SIZE=3 MAXLENGTH=3>\n",atoi(s0));
	printf("<STRONG>.</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"s1\" VALUE=\"%d\" SIZE=3 MAXLENGTH=3>\n",atoi(s1));
	printf("<STRONG>.</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"s2\" VALUE=\"%d\" SIZE=3 MAXLENGTH=3>\n",atoi(s2));
	printf("<STRONG>.</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"s3\" VALUE=\"%d\" SIZE=3 MAXLENGTH=3>\n",atoi(s3));
	printf("<STRONG>Port :</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"sp\" VALUE=\"%d\" SIZE=5 MAXLENGTH=5>\n",atoi(sp));
	printf("<BR>\n");

	printf("<STRONG>Dest IP :</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"d0\" VALUE=\"%d\" SIZE=3 MAXLENGTH=3>\n",atoi(d0));
	printf("<STRONG>.</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"d1\" VALUE=\"%d\" SIZE=3 MAXLENGTH=3>\n",atoi(d1));
	printf("<STRONG>.</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"d2\" VALUE=\"%d\" SIZE=3 MAXLENGTH=3>\n",atoi(d2));
	printf("<STRONG>.</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"d3\" VALUE=\"%d\" SIZE=3 MAXLENGTH=3>\n",atoi(d3));
	printf("<STRONG>Port :</STRONG>\n");
	printf("<INPUT TYPE=\"text\" NAME=\"dp\" VALUE=\"%d\" SIZE=5 MAXLENGTH=5>\n",atoi(dp));
	printf("<BR>\n");
	printf("<BR>\n");
	printf("<INPUT TYPE=\"submit\" VALUE=\"Test this packet\">\n");
	printf("</FORM>\n");

	printf("</BODY></HTML>\n");
	return(0);
}	

